unit CHILDTAB;

interface

uses Windows, Messages, SysUtils, Classes, Forms, Controls,
  StdCtrls, ComCtrls, TntForms,
  ActiveX, ActnList, StdActns, Menus, Dialogs,
  TextFileEncoding, codedlgunit,
  UniControl, wNotePad, NotePadView, tntmenus, FixTntTabPage;

type
  TChildFrame = class(TTntForm)
    NotePad1: TwNotePad;
    PopupMenu1: TTntPopupMenu;
    Close1: TTntMenuItem;
    Reload1: TTntMenuItem;
    Parent1: TTntMenuItem;
    Save1: TTntMenuItem;
    CopyDocPath: TTntMenuItem;
    N1: TTntMenuItem;
    procedure CopyDocPathClick(Sender: TObject);
    procedure NotePad1ViewChanged(Sender: TObject);
    procedure NotePad1FilesDroped(Sender: TObject;
      Files: array of WideString);
    procedure Close1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure Reload1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Parent1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure NotePad1ModifiedChanged(Sender: TObject);
    procedure NotePad1RulerDown(Sender: TObject; Col: Integer);
    procedure NotePad1RulerMove(Sender: TObject; Col: Integer);
    procedure NotePad1RulerUp(Sender: TObject; Col: Integer);
  private
    FDocPath: WideString;
    ThisTab: TTabSheetFix;
    FOpenCode: TFileCode;
    SaveDlg1:TCodeOpenSave;
    FFileTime: integer;
    procedure DocLoad(code: TFileCode);
    procedure ChangeTitle(value: WideString);
    function SaveToFileSub(const PathName: WideString; code: TFileCode): boolean;
    procedure SetOpenCode(const Value: TFileCode);
    procedure ChildWriteHist(const PathName: WideString; WriteMark: boolean);
    procedure ChildReadHist(const PathName: WideString);
  protected
    procedure CreateHandle; override;
    procedure SetDocPath(const Value: WideString);
    property OpenCode: TFileCode read FOpenCode write SetOpenCode;
  public
    constructor Create(AOwner:TComponent;const fn:widestring;code:TFileCode);reintroduce;
    destructor Destroy; override;
    function Closed: boolean;
    procedure DocReload(code: TFileCode);
    function TabSavedAs:boolean;
    function TabSaved:boolean;
    function TabCanClose:boolean;
    function CheckFileTime: boolean;
    property DocPath: WideString read FDocPath write SetDocPath;
  end;

implementation

uses ShellAPI, DM, wsFileOp, wsMemIni, ChildPopupMenu, codeconvsub, ClipBrdW, main;

{$R *.dfm}

function GetFileTime(const AFileName: WideString): integer;
var
  sr: TSearchRecW;
begin
  try
    if FindFirstW(AFileName, faAnyFile, sr) = 0 then begin
      Result := sr.Time;
    end else Result := 0;
  finally
    FindCloseW(sr);
  end;
end;

{ TChildFrame }

function TChildFrame.Closed: boolean;
begin
  Result := TabCanClose;
  if not Result then exit;
  SaveDlg1.Free;
  Self.Hide;//eq
  Self.Parent := nil;
  ThisTab.PageControl := nil;
//  if Mana22Form.NotePad1.DocumentParent = NotePad1 then begin
//    Mana22Form.NotePad1.DocumentParent := nil;
//    Mana22Form.NotePad1.EditMode := hmDefault;
//  end;
  if ManaMain.MMGetKeyMacro.Control = NotePad1 then
    ManaMain.MMGetKeyMacro.Control := nil;
  if FileExists2(DocPath) and (not NotePad1.Modified) then ChildWriteHist(DocPath, true);
  Free;
end;

procedure TChildFrame.CopyDocPathClick(Sender: TObject);
begin
  PutToClipBrd(FDocPath, false);
end;

constructor TChildFrame.Create(AOwner: TComponent; const fn: widestring;
  code: TFileCode);
begin
  inherited Create(AOwner);
    TabStop := false;
    OldCreateOrder := false;
    Align := alClient;
    BorderStyle := bsNone;
  FDocPath := fn;
  OpenCode := code;
end;

procedure TChildFrame.DocLoad(code: TFileCode);
var
  e, e1: boolean;
begin
  if Length(FDocPath) = 0 then begin
    NotePad1.WordWrapCount := FWordWrapCount;
    NotePad1.WordWrap := FWordWrap;
  end else begin
    NotePad1.LoadFromString('ǂݍݒ...');
    NotePad1.Update;
    NotePad1.LoadFromString(LoadFromFile(FDocPath, code, true, e, e1));
    if e then NotePad1.LoadFromString('IIǂݍ݃G[II') else begin
      FFileTime := GetFileTime(FDocPath);
      ChildReadHist(FDocPath);
      NotePad1.ScrollToCaret;
    end;
    NotePad1.WordWrapCount := FWordWrapCount;
    NotePad1.WordWrap := FWordWrap;
    NotePad1.SetModeFromPath(FDocPath);
    if e1 and (not e) then
      MessageBoxW(Handle, 'sȃf[^܂܂Ă܂I' + #13#10 +
        'ނJ܂AŜ߁A㏑ۑȂłB',
        PWChar(TntApplication.Title),
        MB_OK or MB_ICONINFORMATION or MB_TASKMODAL);
  end;
  if code = fcNone then OpenCode := fcANSI else OpenCode := code;
  ChangeTitle(DocPath);
  Application.Restore;
end;

procedure TChildFrame.FormCreate(Sender: TObject);
begin
  ThisTab.Caption := TabShort(FDocPath);
  ThisTab.ImageIndex := 15;
  self.Parent := ThisTab;
  Caption:='';
//  NotePad1.PopupMenu.Images := PopupMenu1.Images;
  NotePad1.PopupMenu := NotePadPopup;
  NotePad1.Options := FNotePadOptions;
  NotePad1.SearchText := FHighlightText;
  NotePad1.SearchIgCase := FSearchIgCase;
  NotePad1.SearchWithRegEx := FSearchWithRegEx;
  NotePad1.SetModeExt(hmHtml, ManaMain.MMGetSubEditor.GetModeExt(hmHtml));
  NotePad1.SetModeExt(hmCSharp, ManaMain.MMGetSubEditor.GetModeExt(hmCSharp));
  NotePad1.SetModeExt(hmDelphi, ManaMain.MMGetSubEditor.GetModeExt(hmDelphi));
  NotePad1.SetModeExt(hmJScript, ManaMain.MMGetSubEditor.GetModeExt(hmJScript));
  NotePad1.SetModeExt(hmVBScript, ManaMain.MMGetSubEditor.GetModeExt(hmVBScript));
  NotePad1.SetModeExt(hmPython, ManaMain.MMGetSubEditor.GetModeExt(hmPython));
  NotePad1.SetModeExt(hmCpp, ManaMain.MMGetSubEditor.GetModeExt(hmCpp));
  NotePad1.SetModeExt(hmJava, ManaMain.MMGetSubEditor.GetModeExt(hmJava));
  NotePad1.SetModeExt(hmPerl, ManaMain.MMGetSubEditor.GetModeExt(hmPerl));
  NotePad1.SetModeExt(hmRuby, ManaMain.MMGetSubEditor.GetModeExt(hmRuby));
  NotePad1.SetModeExt(hmVisualBasic, ManaMain.MMGetSubEditor.GetModeExt(hmVisualBasic));
  NotePad1.SetModeExt(hmCss, ManaMain.MMGetSubEditor.GetModeExt(hmCss));
  NotePad1.SetModeExt(hmBat, ManaMain.MMGetSubEditor.GetModeExt(hmBat));
  SaveDlg1:=TCodeOpenSave.Create;
  SaveDlg1.Filter:='ׂẴt@C'#0'*.*'#0#0;
  Show;
  ShowControl(NotePad1);
  Windows.SetFocus(NotePad1.Handle);
  //NotePad1.SetFocus;
  DocLoad(OpenCode);
end;

procedure TChildFrame.NotePad1ViewChanged(Sender: TObject);
begin
  ManaMain.MMNotePadViewChanged(Sender);
  ChangeTitle(FDocPath);
end;

procedure TChildFrame.DocReload(code: TFileCode);
var
//  OldSelEnd:integer;
  e, e1: boolean;
begin
  ShowControl(ThisTab);
  ShowControl(NotePad1);
  NotePad1.SetFocus;
//  OldSelEnd := NotePad1.SelectionStart + NotePad1.SelectionLength;
  if not FileExists2(DocPath) then begin
      MessageBoxW(Handle, 't@C݂܂I',
        PWChar(TntApplication.Title),
        MB_OK or MB_ICONINFORMATION or MB_TASKMODAL);
      exit;
  end;//if
  if NotePad1.Modified then begin
      if MessageBoxW(Handle, 'ύX𖳎ĊJ܂H',
      PWChar(TntApplication.Title),
        MB_OKCANCEL or MB_ICONQUESTION or MB_TASKMODAL) = idCancel then exit;
    ChildWriteHist(FDocPath, false);
  end else begin
    ChildWriteHist(FDocPath, true);
  end;//if
  if code = fcNone then code := OpenCode;
  NotePad1.LoadFromString('ǂݍݒ...');
  NotePad1.WordWrap := wwNone;
  NotePad1.EditMode := hmDefault;
  NotePad1.Update;
  NotePad1.LoadFromString(LoadFromFile(FDocPath, code, true, e, e1));
  if e then NotePad1.LoadFromString('IIǂݍ݃G[II') else begin
    FFileTime := GetFileTime(FDocPath);
    ChildReadHist(FDocPath);
    NotePad1.ScrollToCaret;
  end;
  NotePad1.WordWrap := FWordWrap;
  NotePad1.SetModeFromPath(FDocPath);
//  NotePad1.SelectionStart := OldSelEnd;
  ManaMain.MMLogAddString1(DocPath);
  ManaMain.MMAppWriteHistINI;
  if code = fcNone then OpenCode := fcANSI else OpenCode := code;
  ChangeTitle(FDocPath);
  Application.Restore;
end;

procedure TChildFrame.NotePad1FilesDroped(Sender: TObject;
  Files: array of WideString);
begin
  ManaMain.MMNotePadFilesDroped(Sender, Files);
end;

procedure TChildFrame.ChangeTitle(value: WideString);
var
  s, ss: WideString;
begin
  ss := FileCodeString[ord(OpenCode)];
  DocPath := value;
  if Length(value) > 0 then s := ExtractFileNameW(Value) else s := NotitleCaption;
  if NotePad1.Modified then s := WideString('*') + s;
  ManaMain.MMSetCaption(s + ss + WideString(' - ') + TntApplication.Title);
  ManaMain.MMGetStatusBar.Panels[2].Caption := ss;
  if Length(value) > 0 then s := TabShort(value) else s := NotitleCaption;
  if NotePad1.Modified then s := WideString('*') + s;
  ThisTab.Caption := s;
  if NotePad1.Modified then ThisTab.ImageIndex := 16 else ThisTab.ImageIndex := 15;
  if not NotePad1.Focused then begin
    ManaMain.MMSetCaption(TntApplication.Title);
    ManaMain.MMGetStatusBar.Panels[2].Caption := '';
    ManaMain.MMGetStatusBar.Panels[1].Caption := '';
    //^uǉ폜łOnChangeȂ
    //KillFocusłChangeTitle
    exit;
  end;
end;

procedure TChildFrame.SetDocPath(const Value: WideString);
begin
  FDocPath := Value;
  if length(value)>0 then
    Self.Hint:=Value
  else
    Self.Hint:=NotitleHint;
end;

function TChildFrame.TabCanClose: boolean;
var
  ws: widestring;
begin
  if NotePad1.Modified then begin
    showcontrol(ThisTab);
    ShowControl(NotePad1);
    NotePad1.SetFocus;
    if Length(DocPath) = 0 then
      ws := NotitleCaption
    else
      ws:=ExtractFileNameW(DocPath);
    case MessageBoxW(Handle,'ύXۑ܂H', pWchar(ws),MB_YESNOCANCEL or MB_ICONQUESTION or MB_TASKMODAL) of
      idYes:Result:=TabSaved;
      idNo:Result:=true;
      else Result:=false;
    end;//case
  end else Result:=true;
end;

function TChildFrame.TabSaved: boolean;
begin
  Result := false;
  if FileExists2(FDocPath) then begin
    if not SaveToFileSub(FDocPath, OpenCode) then exit;
    NotePad1.Modified := false;
    NotePad1.ScrollToCaret;
    ManaMain.MMLogAddString1(FDocPath);
    ManaMain.MMAppWriteHistINI;
    Result := true;
  end else Result := TabSavedAs;
end;

function TChildFrame.TabSavedAs: boolean;
var
  fc:TFileCode;
  AChild: TChildFrame;
  AExt: WideString;
begin
  Result := false;
  //݂t@CŖOtꍇ͂̃pX
  //t@CȂĂfBNgꍇ̃pX
  if FileExists2(FDocPath) then SaveDlg1.PathName := FDocPath else begin
    if DirectoryExists2(ExtractFileDirW(FDocPath)) then SaveDlg1.PathName := FDocPath else begin
      //_CAOɃt@C@͒ʗpȂ
      //SaveDlg1.PathName := ExtractFileNameW(FDocPath);
      //PathNameɃfBNĝݓ̂_
      //SaveDlg1.PathName := 'hoge';
      //SaveDlg1.InitialDir := 'hoge';
      //݂ȂfBNgƃJgfBNgɂȂႤ
      SaveDlg1.PathName := ExtractFileNameW(FDocPath);
      if DirectoryExists2(ExtractFileDirW(FLastSavedFile)) then
        SaveDlg1.InitialDir := ExtractFileDirW(FLastSavedFile) else SaveDlg1.InitialDir := '';
    end;
  end;
  if FAddExtTXT then begin
    AExt := NotePad1.CurrentMode.GetDefExt;
    if length(AExt) = 0 then AExt := 'txt';
    SaveDlg1.DefExt := AExt;
  end else SaveDlg1.DefExt := '';
  if not SaveDlg1.SaveExcute(Handle) then exit;
  ///Ⴄt@Cꂽꍇ
  if FileExists2(SaveDlg1.PathName) then SaveDlg1.PathName := GetLongPathOfW(SaveDlg1.PathName);
  //ɊJĂt@C
  AChild := TChildFrame(ManaMain.MMTabExists(SaveDlg1.PathName));
  if (AChild <> nil) and (AChild <> Self) then begin
    MessageBoxW(Handle, 'ɊJĂt@Cւ̏㏑͂ł܂I',
        PWChar(TntApplication.Title),
        MB_OK or MB_ICONINFORMATION or MB_TASKMODAL);
    exit;
  end;
  fc := OpenCode;
  if SaveDlg1.Codepage <> 0 then
      fc := TFileCode(SaveDlg1.Codepage);
  if not SaveToFileSub(SaveDlg1.PathName, fc) then exit;
  OpenCode := fc;
  FDocPath := SaveDlg1.PathName;
  NotePad1.Modified := false;
  NotePad1.ScrollToCaret;
  ManaMain.MMLogAddString1(FDocPath);
  ManaMain.MMAppWriteHistINI;
  Result := true;
end;

procedure TChildFrame.PopupMenu1Popup(Sender: TObject);
begin
  Reload1.Enabled := FDocPath <> '';
  Parent1.Enabled := FDocPath <> '';
  CopyDocPath.Enabled := FDocPath <> '';
end;

procedure TChildFrame.Close1Click(Sender: TObject);
begin
  if not Closed then exit;
  if ManaMain.MMGetPageControl.PageCount = 0 then ManaMain.MMCreateMDIChild('', fcNONE);
  if (ManaMain.MMGetPageControl.ActivePage.Owner is  TChildFrame) then
    TChildFrame(ManaMain.MMGetPageControl.ActivePage.Owner).NotePad1.SetFocus;
end;

procedure TChildFrame.Reload1Click(Sender: TObject);
begin
  DocReload(fcNONE);
end;

procedure TChildFrame.Save1Click(Sender: TObject);
begin
  TabSaved;
end;

procedure TChildFrame.Parent1Click(Sender: TObject);
begin
  ShellExecuteW(0, 'open', PWChar(ExtractFileDirW(FDocPath)),nil, nil, SW_SHOW);
end;

procedure TChildFrame.NotePad1ModifiedChanged(Sender: TObject);
begin
  ChangeTitle(FDocPath);
end;

function TChildFrame.SaveToFileSub(const PathName: WideString; code: TFileCode): boolean;
var
  usedefchar:bool;
  ACode: TFileCode;
  i: integer;
  PW: PWChar;
  len: integer;
const
  WC_NO_BEST_FIT_CHARS = $00000400;
  //WC_NO_BEST_FIT_CHARS ANZgL̂镶Ȃ񂩂?ɂႨ
  //WC_COMPOSITECHECK    ꂪȂƕϊłȂHs
  //WC_SEPCHARS          ŕۑłȂ番܂
  //WC_DEFAULTCHAR       ςȂƂɕςȕ͗?ɂ܂
  //{Ń`FbN̎
  //WC_NO_BEST_FIT_CHARS or WC_COMPOSITECHECK or WC_SEPCHARS
  //{ŕϊ̎̓VXeł0gĂ悤ȁH
begin
  usedefchar := false;
  PW := NotePad1.ToPointer(0);
  len := NotePad1.TextLength;
  case code of
    fcNONE, fcANSI, fcJIS: begin
      WideCharToMultiByte(932, WC_NO_BEST_FIT_CHARS {or WC_COMPOSITECHECK or WC_SEPCHARS},
        PW, len, nil, 0, nil, @usedefchar);
    end;
    fcASCII: begin
      WideCharToMultiByte(1252, WC_NO_BEST_FIT_CHARS {or WC_COMPOSITECHECK or WC_SEPCHARS},
        PW, len, nil, 0, nil, @usedefchar);
    end;
    fc1251: begin
      WideCharToMultiByte(1251, WC_NO_BEST_FIT_CHARS {or WC_COMPOSITECHECK or WC_SEPCHARS},
        PW, len, nil, 0, nil, @usedefchar);
    end;
    fcBIG5: begin
      WideCharToMultiByte(950, WC_NO_BEST_FIT_CHARS {or WC_COMPOSITECHECK or WC_SEPCHARS},
        PW, len, nil, 0, nil, @usedefchar);
    end;
    fcGB2312: begin
      WideCharToMultiByte(936, WC_NO_BEST_FIT_CHARS {or WC_COMPOSITECHECK or WC_SEPCHARS},
        PW, len, nil, 0, nil, @usedefchar);
    end;
    fcEUCKR: begin
      WideCharToMultiByte(949, WC_NO_BEST_FIT_CHARS {or WC_COMPOSITECHECK or WC_SEPCHARS},
        PW, len, nil, 0, nil, @usedefchar);
    end;
    fcEUC: begin
      for i := 0 to len - 1 do begin
        if (Word(PW^) > $7F) and (UTF16ToJIS[Word(PW^)] = 0) then begin
          usedefchar := true;
          //ShowMessage(inttostr(i) + ':'+InttoHex(Word(PW^), 4));
          break;
        end;
        inc(PW);
      end;
    end;
  end;
  if usedefchar then begin
    ACode := OpenCode;
    OpenCode := code;
//    NotePad1.Update;
    try
      case MessageBoxW(Handle,
        'w肵R[hŕۑłȂUnicode܂܂Ă܂B' + #13#10 +
        '̂܂ܕۑ܂H' + #13#10 +
        #13#10 +
        '͂: VXe̕ɒuĕۑ܂B' + #13#10 +
        ': ۑ𒆎~܂Bʂ̕R[hw肵ĕۑĂB',
        PWChar(TntApplication.Title),MB_YESNO or MB_ICONQUESTION or MB_TASKMODAL) of
        idYes: begin
          //IɃZ[u
        end;
        else begin
          Result := false;
          exit;
        end;
      end;
    finally
      OpenCode := ACode;
    end;
  end;
  Result := SaveToFile(PathName, NotePad1.TextIf, code);
  if Result then begin
    FFileTime := GetFileTime(PathName);
    FLastSavedFile := PathName;
    ChildWriteHist(PathName, true);
  end else MessageBoxW(Handle,'ݎsI'+#13#10+'l錴:'+#13#10+
    '̃t@C܂͕ۑ悪ی삳ĂB'+#13#10+'fBXN^B',
    PWChar(TntApplication.Title), MB_OK or MB_ICONERROR or MB_TASKMODAL);
end;

procedure TChildFrame.NotePad1RulerDown(Sender: TObject; Col: Integer);
begin
  ManaMain.MMNotePadRulerDown(Sender, Col);
end;

procedure TChildFrame.NotePad1RulerMove(Sender: TObject; Col: Integer);
begin
  ManaMain.MMNotePadRulerMove(Sender, Col);
end;

procedure TChildFrame.NotePad1RulerUp(Sender: TObject; Col: Integer);
begin
  ManaMain.MMNotePadRulerUp(Sender, Col);
end;

procedure TChildFrame.SetOpenCode(const Value: TFileCode);
begin
  FOpenCode := Value;
  case Value of
    fcNONE, fcANSI, fcJIS: begin
      NotePad1.CodePage := cpJapanese;
    end;
    fcASCII: begin
      NotePad1.CodePage := cpAscii;
    end;
    fc1251: begin
      NotePad1.CodePage := cp1251;
    end;
    fcBIG5: begin
      NotePad1.CodePage := cpBig5;
    end;
    fcGB2312: begin
      NotePad1.CodePage := cpGB2312;
    end;
    fcEUCKR: begin
      NotePad1.CodePage := cpEUCKR;
    end;
    fcEUC: begin
      NotePad1.CodePage := cpEUCJP;
    end;
    else NotePad1.CodePage := cpNone;
  end;

end;

procedure TChildFrame.CreateHandle;
var
  i:integer;
begin
  inherited;
  //Â񂾉B
  if not (csDesigning in ComponentState) then begin
    if ThisTab = nil then begin
      ThisTab := TTabSheetFix.Create(self);
      ThisTab.ParentFont := true;
      ThisTab.ShowHint := false;
      ThisTab.TabStop := false;
      for i := 0 to Mana22Form.ComponentCount - 1 do begin
        if Mana22Form.Components[i] is TTntPageFix then begin
          ThisTab.PageControl := TTntPageFix(Mana22Form.Components[i]);
          break;
        end;
      end;
    end;
  end;
end;

destructor TChildFrame.Destroy;
begin
  if not (csDesigning in ComponentState) then begin
    Self.Hide;//eq
    Self.Parent := nil;
    ThisTab.PageControl := nil;
    ThisTab.Free;
  end;
  inherited;
end;

procedure TChildFrame.ChildReadHist(const PathName: WideString);
var
  i:integer;
  u7: AnsiString;
begin
  if not Assigned(FHistIni) then exit;
  SetLength(u7, WideCharToMultiByte(CP_UTF7, 0, pwchar(PathName), Length(PathName),nil,0,nil,nil));
  WideCharToMultiByte(CP_UTF7,0,pwchar(PathName),Length(PathName),pchar(u7),length(u7),nil,nil);
  i := 0;
  while FHistINI.ValueExists(u7, IntToStr(i)) do begin
    NotePad1.AddMark(FHistINI.ReadInteger(u7, IntToStr(i), 0));
    inc(i);
  end;
  NotePad1.SelectionStart := FHistINI.ReadInteger(u7, 'CARET', 0);
end;

procedure TChildFrame.ChildWriteHist(const PathName: WideString; WriteMark: boolean);
var
  i:integer;
  u7: AnsiString;
begin
  if not Assigned(FHistIni) then exit;
  SetLength(u7, WideCharToMultiByte(CP_UTF7, 0, pwchar(PathName), Length(PathName),nil,0,nil,nil));
  WideCharToMultiByte(CP_UTF7,0,pwchar(PathName),Length(PathName),pchar(u7),length(u7),nil,nil);
  if WriteMark then FHistIni.EraseSection(u7);
  FHistIni.WriteInteger(u7, 'CARET', NotePad1.SelectionStart + NotePad1.SelectionLength);
  if WriteMark then for i := 0 to NotePad1.MarkCount - 1 do begin
    FHistIni.WriteInteger(u7, Inttostr(i), NotePad1.Marks[i]);
  end;
  //f[^͎̂ōŌȊO͏܂ȂĂǂ
  //UpdateHistIni;
end;

function TChildFrame.CheckFileTime: boolean;
var
  i: integer;
begin
  Result := false;
  if not FileExists2(FDocPath) then exit;
  if FFileTime = 0 then exit;
  i := GetFileTime(FDocPath);
  if i = 0 then exit;
  if i = FFileTime then exit;
  Result := true;
  Showcontrol(ThisTab);
  ShowControl(NotePad1);
  NotePad1.SetFocus;
  case MessageBoxW(Handle,
      '^ȊÕ\tgł̃t@CXV܂B' + #13#10 +
      'ēǍs܂H',
      PWChar(TntApplication.Title),MB_YESNO or MB_ICONQUESTION or MB_TASKMODAL) of
    idYes: begin
      DocReload(fcNone);
    end;
    else begin
    end;
  end;
  FFileTime := i;//xƊmFȂ߁B
end;

end.
