unit OptionDialogUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  NotePadView, TntClasses,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, TntExtCtrls, TntStdCtrls, Buttons,
  PSpeedButton, Spin, FixTntCombo, UniControl, Grids, TntGrids, codedlgunit,
  wNotePad, PLBxCtls, ShortCutUnit, TKCollapsePanel, TntForms;

type
  TOptionDialog = class(TTntForm)
    Button_OK: TTntButton;
    Button_Cancel: TTntButton;
    Han_CheckBox1: TTntCheckBox;
    Zen_CheckBox1: TTntCheckBox;
    Tab_CheckBox1: TTntCheckBox;
    Wrap_CheckBox1: TTntCheckBox;
    Ret_CheckBox1: TTntCheckBox;
    EOF_CheckBox1: TTntCheckBox;
    CountWrap_CheckBox1: TTntCheckBox;
    Right_CheckBox1: TTntCheckBox;
    Ruler_CheckBox1: TTntCheckBox;
    LeftBar_CheckBox1: TTntCheckBox;
    HanSpeedButton1: TPSpeedButton;
    ZenSpeedButton1: TPSpeedButton;
    TabSpeedButton1: TPSpeedButton;
    WrapSpeedButton1: TPSpeedButton;
    RetSpeedButton1: TPSpeedButton;
    EOFSpeedButton1: TPSpeedButton;
    ULSpeedButton1: TPSpeedButton;
    RightSpeedButton1: TPSpeedButton;
    RulerSpeedButton1: TPSpeedButton;
    LeftBarSpeedButton1: TPSpeedButton;
    Label25: TTntLabel;
    DefFGSpeedButton1: TPSpeedButton;
    Label35: TTntLabel;
    DefBGSpeedButton1: TPSpeedButton;
    Wrap_RadioGroup1: TTntRadioGroup;
    Label16: TTntLabel;
    SpinEdit_WrapByte: TSpinEdit;
    Label4: TTntLabel;
    SpinEdit_MarginLine: TSpinEdit;
    TabCount_ComboBox1: TTntComboBoxFix;
    Label5: TTntLabel;
    AutoIndent_CheckBox1: TTntCheckBox;
    ColorDialog1: TColorDialog;
    ListBox_Token1: TTntListBox;
    TokenFG_CheckBox1: TTntCheckBox;
    TokenFGSpeedButton1: TPSpeedButton;
    TokenStyle_GroupBox1: TTntGroupBox;
    TokenBold_CheckBox1: TTntCheckBox;
    TokenUL_CheckBox1: TTntCheckBox;
    TokenItalyCheckBox1: TTntCheckBox;
    StringGrid_Ext: TTntStringGrid;
    Image1: TTntImage;
    Panel3: TTntPanel;
    Button_BMP: TTntButton;
    Button_BMPClear: TTntButton;
    SpinEdit_AlphaBlend: TSpinEdit;
    Label7: TTntLabel;
    PropListBox_ShortCut: TPropListBox;
    SJISSpeedButton1: TPSpeedButton;
    SJIS_CheckBox1: TTntCheckBox;
    ScrollBox1: TTntScrollBox;
    Collapse2: TTKCollapsePanel;
    Collapse3: TTKCollapsePanel;
    Collapse4: TTKCollapsePanel;
    Collapse6: TTKCollapsePanel;
    Collapse7: TTKCollapsePanel;
    Collapse5: TTKCollapsePanel;
    MarkSpeedButton1: TPSpeedButton;
    Label1: TTntLabel;
    GroupBox1: TTntGroupBox;
    UL_CheckBox1: TTntCheckBox;
    AddExt_CheckBox: TTntCheckBox;
    Label2: TTntLabel;
    KeepCol_CheckBox1: TTntCheckBox;
    RulerEnabled_CheckBox1: TTntCheckBox;
    procedure UL_CheckBox1Click(Sender: TObject);
    procedure CollapseCollapseBefore(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ListBox_Token1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ListBox_Token1Click(Sender: TObject);
    procedure TokenFGSpeedButton1Click(Sender: TObject);
    procedure TokenFG_CheckBox1Click(Sender: TObject);
    procedure TokenBold_CheckBox1Click(Sender: TObject);
    procedure TokenUL_CheckBox1Click(Sender: TObject);
    procedure TokenItalyCheckBox1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button_BMPClearClick(Sender: TObject);
    procedure Button_BMPClick(Sender: TObject);
    procedure PropListBox_ShortCutDropDown(Sender: TObject; Index: Integer;
      List: TStrings);
    procedure PropListBox_ShortCutCheck(Sender: TObject; Index: Integer;
      var CanUpdate: Boolean);
    procedure PropListBox_ShortCutData(Sender: TObject; Index: Integer;
      var Item: TPropItem);
    procedure SJIS_CheckBox1Click(Sender: TObject);
  private
    FBitmapPath: WideString;
    FGraphic: TBitmap;
    BMPDlg1:TCodeOpenSave;
    FKeyList: TStringList;
    function GetOptions: TNotePadOptions;
    procedure SetOptions(const Value: TNotePadOptions);
    function GetWordWrap: TWordWrap;
    procedure SetWordWrap(const Value: TWordWrap);
    function GetWordWrapCount: integer;
    procedure SetWordWrapCount(const Value: integer);
    procedure LoadBitmap(const PathName: WideString);
    procedure SetBitmapPath(const Value: WideString);
    function GetShortCutList: TShortCutList;
    procedure SetShortCutList(const Value: TShortCutList);
    procedure CheckOKButton;
    procedure CheckWithoutClick(ACheckBox: TTntCheckBox; Value: boolean);
    { Private 錾 }
  public
    function IsShortCut(var Message: TWMKey): Boolean; override;
    procedure GetExts(const Value: TTntStringList);
    procedure SetExts(const Value: TTntStringList);
    property WordWrap: TWordWrap read GetWordWrap write SetWordWrap;
    property WordWrapCount: integer read GetWordWrapCount write SetWordWrapCount;
    property Options: TNotePadOptions read GetOptions write SetOptions;
    property BitmapPath: WideString read FBitmapPath write SetBitmapPath;
    property ShortCutList: TShortCutList read GetShortCutList write SetShortCutList;
    { Public 錾 }
  end;

var
  OptionDialogTab: integer = 0;

implementation

uses Math, ImageLoad, wsFileOp, FontUtils, Menus;

{$R *.dfm}

var
  FOptions: TNotePadOptions;

procedure TOptionDialog.FormCreate(Sender: TObject);
begin
  ListBox_Token1.Items.Text :=
    'N' + #13#10 +
    'SpJi' + #13#10 +
    'Sp' + #13#10 +
    'Spp' + #13#10 +
    'Sp' + #13#10 +
    'SpL' + #13#10 +
    'Sp' + #13#10 +
    'p' + #13#10 +
    'pp' + #13#10 +
    'pL' + #13#10 +
    'l' + #13#10 +
    '\' + #13#10 +
    'E\' + #13#10 +
    'E\' + #13#10 +
    '' + #13#10 +
    '' + #13#10 +
    'HTML^O' + #13#10 +
    'Rg' + #13#10 +
    'fBNeBu' + #13#10 +
    'qA ' + #13#10 +
    'O' + #13#10 +
    '䕶' + #13#10 +
    '̑̕';
  StringGrid_Ext.Cells[0, 0] := 'HTML/PHP';
  StringGrid_Ext.Cells[0, 1] := 'C';
  StringGrid_Ext.Cells[0, 2] := 'Delphi';
  StringGrid_Ext.Cells[0, 3] := 'JScript';
  StringGrid_Ext.Cells[0, 4] := 'VBScript';
  StringGrid_Ext.Cells[0, 5] := 'Python';
  StringGrid_Ext.Cells[0, 6] := 'C++';
  StringGrid_Ext.Cells[0, 7] := 'Java';
  StringGrid_Ext.Cells[0, 8] := 'Perl';
  StringGrid_Ext.Cells[0, 9] := 'Ruby';
  StringGrid_Ext.Cells[0, 10] := 'Visual Basic';
  StringGrid_Ext.Cells[0, 11] := 'CSS';
  StringGrid_Ext.Cells[0, 12] := 'ob`t@C';
  FGraphic := TBitmap.Create;
  BMPDlg1:=TCodeOpenSave.Create;
  BMPDlg1.Filter:='摜t@C(*.bmp,*.jpg,*.jpeg,*.gif)'#0'*.bmp;*.jpg;*.jpeg;*.gif'#0#0;
  BMPDlg1.Caption:='ǎw';
  BMPDlg1.UseCode:=false;
  FKeyList := TStringList.Create;
end;

function TOptionDialog.GetOptions: TNotePadOptions;
begin
  Result := FOptions;
  Result.ColorFore := DefFGSpeedButton1.Color;
  Result.ColorBack := DefBGSpeedButton1.Color;
  Result.ColorLeftBar := LeftBarSpeedButton1.Color;
  Result.ColorRuler := RulerSpeedButton1.Color;
  Result.ColorCaretLine := ULSpeedButton1.Color;
  Result.ColorSBSpace := HanSpeedButton1.Color;
  Result.ColorDBSpace := ZenSpeedButton1.Color;
  Result.ColorTab := TabSpeedButton1.Color;
  Result.ColorEOF := EOFSpeedButton1.Color;
  Result.ColorLineEnd := RetSpeedButton1.Color;
  Result.ColorWrap := WrapSpeedButton1.Color;
  Result.ColorWrapLine := RightSpeedButton1.Color;
  result.ShowRuler := Ruler_CheckBox1.Checked;
  result.ShowLeftBar := LeftBar_CheckBox1.Checked;
  result.ShowSBSpace := Han_CheckBox1.Checked;
  result.ShowDBSpace := Zen_CheckBox1.Checked;
  result.ShowTab := Tab_CheckBox1.Checked;
  result.ShowEOF := EOF_CheckBox1.Checked;
  result.ShowLineEnd := Ret_CheckBox1.Checked;
  result.ShowWrap := Wrap_CheckBox1.Checked;
  result.ShowWrapLine := Right_CheckBox1.Checked;
  result.LeftBarCountWrap := CountWrap_CheckBox1.Checked;
  if AutoIndent_CheckBox1.Checked then Result.AutoIndent := 1 else Result.AutoIndent := 0;
  Result.KeepCol := KeepCol_CheckBox1.Checked;
  Result.RulerEnabled := RulerEnabled_CheckBox1.Checked;
  Result.TabCount := StrToIntDef(TabCount_ComboBox1.Text, 8);
  Result.LineMargin := SpinEdit_MarginLine.Value;
  Result.AlphaBlend := 255 - SpinEdit_AlphaBlend.Value;
  Result.ColorWideChar := SJISSpeedButton1.Color;
  Result.ColorMark := MarkSpeedButton1.Color;
end;

procedure TOptionDialog.SetOptions(const Value: TNotePadOptions);
begin
  FOptions := Value;
  DefFGSpeedButton1.Color := Value.ColorFore;
  DefBGSpeedButton1.Color := Value.ColorBack;
  LeftBarSpeedButton1.Color := Value.ColorLeftBar;
  RulerSpeedButton1.Color := Value.ColorRuler;
  ULSpeedButton1.Color := Value.ColorCaretLine;
  HanSpeedButton1.Color := Value.ColorSBSpace;
  ZenSpeedButton1.Color := Value.ColorDBSpace;
  TabSpeedButton1.Color := Value.ColorTab;
  EOFSpeedButton1.Color := Value.ColorEOF;
  RetSpeedButton1.Color := Value.ColorLineEnd;
  WrapSpeedButton1.Color := Value.ColorWrap;
  RightSpeedButton1.Color := Value.ColorWrapLine;
  Ruler_CheckBox1.Checked := Value.ShowRuler;
  LeftBar_CheckBox1.Checked := Value.ShowLeftBar;
  Han_CheckBox1.Checked := Value.ShowSBSpace;
  Zen_CheckBox1.Checked := Value.ShowDBSpace;
  Tab_CheckBox1.Checked := Value.ShowTab;
  EOF_CheckBox1.Checked := Value.ShowEOF;
  Ret_CheckBox1.Checked := Value.ShowLineEnd;
  Wrap_CheckBox1.Checked := Value.ShowWrap;
  Right_CheckBox1.Checked := Value.ShowWrapLine;
  CountWrap_CheckBox1.Checked := Value.LeftBarCountWrap;
  AutoIndent_CheckBox1.Checked := Value.AutoIndent = 1;
  KeepCol_CheckBox1.Checked := Value.KeepCol;
  RulerEnabled_CheckBox1.Checked := Value.RulerEnabled;
  case Value.TabCount of
    2: TabCount_ComboBox1.ItemIndex := 0;
    4: TabCount_ComboBox1.ItemIndex := 1;
    6: TabCount_ComboBox1.ItemIndex := 2;
    else  TabCount_ComboBox1.ItemIndex := 3;
  end;
  SpinEdit_MarginLine.Value := Value.LineMargin;

  ListBox_Token1.ItemIndex := 0;
  ListBox_Token1Click(self);
  SpinEdit_AlphaBlend.Value := 255 - Value.AlphaBlend;
  SJISSpeedButton1.Color := Value.ColorWideChar;
  CheckWithoutClick(SJIS_CheckBox1, Value.ColorWideChar <> clNone);
  MarkSpeedButton1.Color := Value.ColorMark;
  CheckWithoutClick(UL_CheckBox1, ULSpeedButton1.Color <> clNone);
end;

function TOptionDialog.GetWordWrap: TWordWrap;
begin
  Result := TWordWrap(Wrap_RadioGroup1.ItemIndex);
end;

procedure TOptionDialog.SetWordWrap(const Value: TWordWrap);
begin
  Wrap_RadioGroup1.ItemIndex := integer(Value);
end;

function TOptionDialog.GetWordWrapCount: integer;
begin
  Result := SpinEdit_WrapByte.Value;
end;

procedure TOptionDialog.SetWordWrapCount(const Value: integer);
begin
  SpinEdit_WrapByte.Value := Value;
end;

procedure TOptionDialog.SpeedButton1Click(Sender: TObject);
begin
  ColorDialog1.Color := TPSpeedButton(Sender).Color;
  if ColorDialog1.Execute then TPSpeedButton(Sender).Color := ColorDialog1.Color;
  ListBox_Token1.Invalidate;
  if Sender = ULSpeedButton1 then begin
    CheckWithoutClick(UL_CheckBox1, ULSpeedButton1.Color <> clNone);
  end else if Sender = SJISSpeedButton1 then begin
    CheckWithoutClick(SJIS_CheckBox1, SJISSpeedButton1.Color <> clNone);
  end;
end;

type
  PStyle = ^TFontStyles;

function GetTokenStyle(Value: integer): PStyle;
begin
  Result := nil;
  case Value of
    0:  Result := @FOptions.StyleLink;
    1:  Result := @FOptions.StyleDBKana;
    2:  Result := @FOptions.StyleDBHira;
    3:  Result := @FOptions.StyleDBAlph;
    4:  Result := @FOptions.StyleDBKanji;
    5:  Result := @FOptions.StyleDBSymbol;
    6:  Result := @FOptions.StyleDBInt;
    7:  Result := @FOptions.StyleSBKana;
    8:  Result := @FOptions.StyleAnk;
    9:  Result := @FOptions.StyleSymbol;
    10: Result := @FOptions.StyleInteger;
    11: Result := @FOptions.StyleReserve;
    12: Result := @FOptions.StyleReserve2;
    13: Result := @FOptions.StyleReserve3;
    14: Result := @FOptions.StyleHighlight;
    15: Result := @FOptions.StyleString;
    16: Result := @FOptions.StyleHtmlTag;
    17: Result := @FOptions.StyleComment;
    18: Result := @FOptions.StylePrefix;
    19: Result := @FOptions.StyleHere;
    20: Result := @FOptions.StyleAlphabetic;
    21: Result := @FOptions.StyleControl;
    22: Result := @FOptions.StyleUnicode;
  end;
end;

function GetTokenColor(Value: integer): PColor;
begin
  Result := nil;
  case Value of
    0:  Result := @FOptions.ColorLink;
    1:  Result := @FOptions.ColorDBKana;
    2:  Result := @FOptions.ColorDBHira;
    3:  Result := @FOptions.ColorDBAlph;
    4:  Result := @FOptions.ColorDBKanji;
    5:  Result := @FOptions.ColorDBSymbol;
    6:  Result := @FOptions.ColorDBInt;
    7:  Result := @FOptions.ColorSBKana;
    8:  Result := @FOptions.ColorAnk;
    9:  Result := @FOptions.ColorSymbol;
    10: Result := @FOptions.ColorInteger;
    11: Result := @FOptions.ColorReserve;
    12: Result := @FOptions.ColorReserve2;
    13: Result := @FOptions.ColorReserve3;
    14: Result := @FOptions.ColorHighlight;
    15: Result := @FOptions.ColorString;
    16: Result := @FOptions.ColorHtmlTag;
    17: Result := @FOptions.ColorComment;
    18: Result := @FOptions.ColorPrefix;
    19: Result := @FOptions.ColorHere;
    20: Result := @FOptions.ColorAlphabetic;
    21: Result := @FOptions.ColorControl;
    22: Result := @FOptions.ColorUnicode;
  end;
end;

procedure TOptionDialog.ListBox_Token1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  ws: widestring;
begin
  with (Control as TTntListBox).Canvas do
  begin
    Brush.Color := DefBGSpeedButton1.Color;
    Brush.Style := bsSolid;
    FillRect(Rect);
    ws := ListBox_Token1.Items[index];
    Font.Style := GetTokenStyle(index)^;
    Brush.Style := bsClear;
    if odSelected in State then begin
      Font.Color := DefFGSpeedButton1.Color;
    end else begin
      Font.Color := GetTokenColor(index)^;
      if Font.Color = clNone then Font.Color := DefFGSpeedButton1.Color;
    end;
    //Font.Size := Font.Size - 1;
    TextOut(Rect.Left,Rect.Top,ws);
    if odSelected in State then
      BitBlt(Handle, Rect.Left, Rect.Top,
        Rect.Right - Rect.Left, Rect.Bottom - Rect.Top,
              Handle, Rect.Left, Rect.Top, NOTSRCCOPY);
  end;
end;

procedure TOptionDialog.ListBox_Token1Click(Sender: TObject);
var
  AColor: PColor;
  AStyle: PStyle;
begin
  AColor := GetTokenColor(ListBox_Token1.ItemIndex);
  AStyle := GetTokenStyle(ListBox_Token1.ItemIndex);
//  TokenFG_CheckBox1.OnClick:=nil;
//  TokenBold_CheckBox1.OnClick:=nil;
//  TokenUL_CheckBox1.OnClick:=nil;
//  TokenItalyCheckBox1.OnClick:=nil;

  TokenFGSpeedButton1.Color := AColor^;
//  TokenFG_CheckBox1.Checked := AColor^ <> clNone;
  CheckWithoutClick(TokenFG_CheckBox1, AColor^ <> clNone);
//  TokenBold_CheckBox1.Checked := fsBold in AStyle^;
  CheckWithoutClick(TokenBold_CheckBox1, fsBold in AStyle^);
//  TokenUL_CheckBox1.Checked := fsUnderline in AStyle^;
  CheckWithoutClick(TokenUL_CheckBox1, fsUnderline in AStyle^);
//  TokenItalyCheckBox1.Checked := fsItalic in AStyle^;
  CheckWithoutClick(TokenItalyCheckBox1, fsItalic in AStyle^);

//  TokenFG_CheckBox1.OnClick:=TokenFG_CheckBox1Click;
//  TokenBold_CheckBox1.OnClick:=TokenBold_CheckBox1Click;
//  TokenUL_CheckBox1.OnClick:=TokenUL_CheckBox1Click;
//  TokenItalyCheckBox1.OnClick:=TokenItalyCheckBox1Click;
end;

procedure TOptionDialog.TokenFGSpeedButton1Click(Sender: TObject);
begin
  ColorDialog1.Color := TPSpeedButton(Sender).Color;
  if ColorDialog1.Execute then
    TPSpeedButton(Sender).Color := ColorDialog1.Color
  else exit;
  GetTokenColor(ListBox_Token1.ItemIndex)^ := ColorDialog1.Color;
  CheckWithoutClick(TokenFG_CheckBox1, ColorDialog1.Color <> clNone);
  ListBox_Token1.Invalidate;
end;

procedure TOptionDialog.TokenFG_CheckBox1Click(Sender: TObject);
var
  AColor: PColor;
begin
  AColor := GetTokenColor(ListBox_Token1.ItemIndex);
  if TokenFG_CheckBox1.Checked then begin
    if AColor^ = clNone then AColor^ := DefFGSpeedButton1.Color;
    TokenFGSpeedButton1.Color := AColor^;
    TokenFGSpeedButton1.Click;
  end else begin
    AColor^ := clNone;
    TokenFGSpeedButton1.Color := clNone;
  end;
  ListBox_Token1.Invalidate;
end;

procedure TOptionDialog.TokenBold_CheckBox1Click(Sender: TObject);
var
  AStyle: PStyle;
begin
  AStyle := GetTokenStyle(ListBox_Token1.ItemIndex);
  if TokenBold_CheckBox1.Checked then
    Include(AStyle^, fsBold)
  else
    Exclude(AStyle^, fsBold);
  ListBox_Token1.Invalidate;
end;

procedure TOptionDialog.TokenUL_CheckBox1Click(Sender: TObject);
var
  AStyle: PStyle;
begin
  AStyle := GetTokenStyle(ListBox_Token1.ItemIndex);
  if TokenUL_CheckBox1.Checked then
    Include(AStyle^, fsUnderline)
  else
    Exclude(AStyle^, fsUnderline);
  ListBox_Token1.Invalidate;
end;

procedure TOptionDialog.TokenItalyCheckBox1Click(Sender: TObject);
var
  AStyle: PStyle;
begin
  AStyle := GetTokenStyle(ListBox_Token1.ItemIndex);
  if TokenItalyCheckBox1.Checked then
    Include(AStyle^, fsItalic)
  else
    Exclude(AStyle^, fsItalic);
  ListBox_Token1.Invalidate;
end;

procedure TOptionDialog.GetExts(const Value: TTntStringList);
var
  i:integer;
begin
  Value.Clear;
  for i := 0 to StringGrid_Ext.RowCount - 1 do
    Value.Add(StringGrid_Ext.Cells[1, i]);
end;

procedure TOptionDialog.SetExts(const Value: TTntStringList);
var
  i: integer;
begin
  for i := 0 to StringGrid_Ext.RowCount - 1 do
    StringGrid_Ext.Cells[1, i] := Value[i];
end;

procedure TOptionDialog.LoadBitmap(const PathName: WideString);
var
  g: TGraphic;
begin
  if FileExists2(FBitmapPath) then begin
    g := LoadImageFromFile(PathName);
    if Assigned(g) then try
      FGraphic.Assign(g);
      //Image1.Picture.Bitmap.Assign(g);
      Image1.Picture.Bitmap.PixelFormat := pf32bit;
      Image1.Picture.Bitmap.Width := Image1.Width;
      Image1.Picture.Bitmap.Height := Image1.Height;
      StretchBlt(Image1.Picture.Bitmap.Canvas.Handle, 0, 0, Image1.Width, Image1.Height,
                 FGraphic.Canvas.Handle, 0, 0, FGraphic.Width, FGraphic.Height, SRCCOPY);
    finally
      g.Free;
    end else Image1.Picture.Bitmap.Assign(nil);
  end else begin
    Image1.Picture.Bitmap.Assign(nil);
  end;
  Image1.Refresh;
end;

procedure TOptionDialog.SetBitmapPath(const Value: WideString);
begin
  FBitmapPath := Value;
  LoadBitmap(Value);
end;

procedure TOptionDialog.FormDestroy(Sender: TObject);
begin
  if Assigned(FGraphic) then FGraphic.Free;
  if Assigned(BMPDlg1) then BMPDlg1.Free;
  if Assigned(FKeyList) then FKeyList.Free;
end;

procedure TOptionDialog.Button_BMPClearClick(Sender: TObject);
begin
  BitmapPath := '';
end;

procedure TOptionDialog.Button_BMPClick(Sender: TObject);
begin
  if FileExists2(FBitmapPath) then BMPDlg1.PathName := FBitmapPath;
  if BMPDlg1.OpenExcute(Handle) then begin
    BitmapPath := BMPDlg1.PathName;
  end;
end;

procedure TOptionDialog.FormShow(Sender: TObject);
begin
  Collapse2.Collapse := true;
  Collapse3.Collapse := true;
  Collapse4.Collapse := true;
  Collapse5.Collapse := true;
  Collapse6.Collapse := true;
  Collapse7.Collapse := true;
  case OptionDialogTab of
    2: Collapse2.Collapse := false;
    3: Collapse3.Collapse := false;
    4: Collapse4.Collapse := false;
    5: Collapse5.Collapse := false;
    6: Collapse6.Collapse := false;
    7: Collapse7.Collapse := false;
  end;
end;

procedure TOptionDialog.PropListBox_ShortCutDropDown(Sender: TObject;
  Index: Integer; List: TStrings);
begin
  List.Assign(AvailKeyList);
end;

procedure TOptionDialog.PropListBox_ShortCutCheck(Sender: TObject;
  Index: Integer; var CanUpdate: Boolean);
begin
  if not isTopMenu(Index)  then begin
    PropListBox_ShortCut.EditText := CheckShortCutText(PropListBox_ShortCut.EditText);
    FKeyList[Index] := PropListBox_ShortCut.EditText;
    PropListBox_ShortCut.Invalidate;
    CheckOKButton;
  end;
end;

procedure TOptionDialog.PropListBox_ShortCutData(Sender: TObject;
  Index: Integer; var Item: TPropItem);
begin
  Item.LanelCaption := MenuArray[Index];
  if isTopMenu(Index)  then begin
    Item.Style := psEdit;
    Item.ReadOnly := true;
    Item.ValueCaption :=  '----';
    Item.LeftColor := clActiveCaption;
    Item.RightColor := clActiveCaption;
  end else begin
    Item.Style := psDropDown;
    Item.ReadOnly := false;
    Item.ValueCaption := CheckShortCutText(FKeyList[Index]);
    if not CheckSameShortCut(Item.ValueCaption, FKeyList) then begin
      Item.LeftColor := clGrayText;
      Item.RightColor := clGrayText;
    end;
  end;
end;

function TOptionDialog.GetShortCutList: TShortCutList;
var
  i: integer;
  P: integer;
begin
  for i := 0 to Length(MenuArray) - 1 do begin
    P := integer(@Result.menuFile) + i * sizeof(TShortCut);
    if isTopMenu(i) then
    begin
    end else begin
      PWord(P)^ := TextToShortCut(FKeyList[i]);
      //FKeyList.Add(ShortCutToText(TShortCut(PWord(P)^)));
    end;
  end;
end;

procedure TOptionDialog.SetShortCutList(const Value: TShortCutList);
var
  i: integer;
  P: integer;
begin
  FKeyList.Clear;
  for i := 0 to Length(MenuArray) - 1 do begin
    P := integer(@Value.menuFile) + i * sizeof(TShortCut);
    if isTopMenu(i) then
    begin
      FKeyList.Add('');
    end else begin
      FKeyList.Add(ShortCutToText(TShortCut(PWord(P)^)));
    end;
  end;
  PropListBox_ShortCut.ItemCount := FKeyList.Count;
end;

procedure TOptionDialog.CheckOKButton;
begin
  if not CheckSameShortCut(FKeyList) then begin
    Button_OK.Enabled := false;
    exit;
  end;

  Button_OK.Enabled := true;
end;

procedure TOptionDialog.SJIS_CheckBox1Click(Sender: TObject);
begin
  if SJIS_CheckBox1.Checked then
    SJISSpeedButton1.Color := DefBGSpeedButton1.Color
  else SJISSpeedButton1.Color := clNone;
end;

function TOptionDialog.IsShortCut(var Message: TWMKey): Boolean;
begin
  if ActiveControl is TTKCollapsePanel then begin
    case Message.CharCode of
      VK_RIGHT: begin
        TTKCollapsePanel(ActiveControl).Collapse := false;
        Result := true;
        exit;
      end;
      VK_LEFT: begin
        TTKCollapsePanel(ActiveControl).Collapse := true;
        Result := true;
        exit;
      end;
      VK_TAB: begin
        if TTKCollapsePanel(ActiveControl).Collapse then begin
          if [ssShift] = KeyDataToShiftState(Message.KeyData) then begin
            Message.CharCode := VK_UP;
            //Shift̓tB^OĂȂH
            Message.KeyData := (not $08000000) and Message.KeyData;
          end else begin
            Message.CharCode := VK_DOWN;
          end;
          Result := inherited IsShortCut(Message);
          exit;
        end;
      end;
    end;
  end;
  Result := inherited IsShortCut(Message);
end;

procedure TOptionDialog.CollapseCollapseBefore(Sender: TObject);
begin
  if not TTKCollapsePanel(Sender).Collapse then exit;
  OptionDialogTab := TTKCollapsePanel(Sender).Tag;
  if Sender <> Collapse2 then Collapse2.Collapse := true;
  if Sender <> Collapse3 then Collapse3.Collapse := true;
  if Sender <> Collapse4 then Collapse4.Collapse := true;
  if Sender <> Collapse5 then Collapse5.Collapse := true;
  if Sender <> Collapse6 then Collapse6.Collapse := true;
  if Sender <> Collapse7 then Collapse7.Collapse := true;
end;

procedure TOptionDialog.UL_CheckBox1Click(Sender: TObject);
begin
  if UL_CheckBox1.Checked then
    ULSpeedButton1.Color := DefFGSpeedButton1.Color
  else ULSpeedButton1.Color := clNone;
end;

procedure TOptionDialog.CheckWithoutClick(ACheckBox: TTntCheckBox; Value: boolean);
var
  AOnClick: TNotifyEvent;
begin
  AOnClick := ACheckBox.OnClick;
  ACheckBox.OnClick := nil;
  ACheckBox.Checked := Value;
  ACheckBox.OnClick := AOnClick;
end;

end.
