unit GrepBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Menus, FixTntCombo,
  comobj, activex, StdActns, ActnList, TntForms,
  gthread, tntmenus, FixTntListView, FixTntTabPage, TntStdCtrls, TntExtCtrls;

type
  TGrepForm = class(TTntForm)
    ListView1: TTntLVFix;
    Panel1: TTntPanel;
    LabelDir1: TTntLabel;
    ComboBoxDir1: TTntComboBoxFix;
    LabelRegex1: TTntLabel;
    ComboBoxRegex1: TTntComboBoxFix;
    ButtonDir1: TTntButton;
    ButtonGrep1: TTntButton;
    EditFilter1: TTntComboBoxFix;
    CheckBoxSubDir1: TTntCheckBox;
    CheckBoxCase1: TTntCheckBox;
    CheckBoxShort1: TTntCheckBox;
    ButtonLog1: TTntButton;
    LabelFilter1: TTntLabel;
    TPopupMenuList1: TTntPopupMenu;
    Open1: TTntMenuItem;
    PopupMenu1: TTntPopupMenu;
    Close1: TTntMenuItem;
    procedure ItemEnter(Sender: TObject);
    procedure ButtonDir1Click(Sender: TObject);
    procedure ButtonGrep1Click(Sender: TObject);
    procedure ButtonLog1Click(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TPopupMenuList1Popup(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FDocPath: WideString;
    ThisTab: TTabSheetFix;
    ExeThread: TGrepThread;
    Natural: boolean;
    LastPathString: WideString;
    procedure AppWriteINI;
    procedure AppReadINI;
    procedure OnTerminate(Sender: TObject);
    procedure KillThread;
    procedure initFilterBox;
    procedure WMSetFocus(var Msg: TWMSetFocus); message WM_SETFOCUS;
  protected
    procedure CreateHandle; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Closed: boolean;
    procedure StartGrep;
    procedure AddNewLine(const pathname,LineString: widestring;LineNum:integer);
    property DocPath: WideString read FDocPath write FDocPath;
  end;

//var
//  GrepForm: TGrepForm;


implementation

{$R *.dfm}

uses DM, wsFileOp, brwsfldr, TextFileEncoding, wsMemIni, tntclasses,
  wNotePad, childtab, Main;

procedure TGrepForm.FormCreate(Sender: TObject);
begin
  Caption := 't@C';
  DocPath := 'eLXg' + Caption;
  ThisTab.Caption := Caption;
  ThisTab.ShowHint := false;
  ThisTab.ImageIndex := 6;
  self.Parent := ThisTab;

  Panel1.Align := altop;
  ExeThread := nil;
  LastPathString := '';
  AppReadINI;
  self.Font := ManaMain.MMGetPageControl.Font;

  initFilterBox;
  Show;
  ManaMain.MMGetPageControl.ActivePage := ThisTab;
  SetFocus;
end;

procedure TGrepForm.ButtonDir1Click(Sender: TObject);
var
  dlg: TBrowseFolderBox;
begin
  dlg := TBrowseFolderBox.Create;
  try
    dlg.Flags := dlg.Flags or bifDontGoBelowDomain or bifStatusText;
    dlg.Title := 'ꏊ̑I';
    if DirectoryExists2(ComboBoxDir1.Text) then dlg.InitFolder := ComboBoxDir1.Text;
    if dlg.Execute(Handle) then begin
      if DirectoryExists2(dlg.SelectFolder) then begin
        if ComboBoxDir1.Items.IndexOf(dlg.SelectFolder) > -1 then
          ComboBoxDir1.Items.Delete(ComboBoxDir1.Items.IndexOf(dlg.SelectFolder));
        ComboBoxDir1.Items.Insert(0, dlg.SelectFolder);
        ComboBoxDir1.ItemIndex := 0;
        AppWriteINI;
      end;
    end;
  finally
    dlg.Free;
  end;
end;

procedure TGrepForm.ButtonGrep1Click(Sender: TObject);
begin
  if ExeThread <> nil then begin
//    repeat//{^vȂ̂ŁAEĂ݂
      KillThread;
//      Application.ProcessMessages;
//    until ExeThread = nil;
  end
  else StartGrep;
end;

procedure TGrepForm.ButtonLog1Click(Sender: TObject);
var
  sl:TTntStringList;
  i:integer;
begin
  if (ListView1.Items.Count > 0) and (GetLastActivePopup(ManaMain.MMGetHandle) = ManaMain.MMGetHandle) then begin
    sl:=TTntStringList.Create;
    try
      sl.Add(LastPathString);
      for i:=0 to ListView1.Items.Count-1 do begin
        if ListView1.Items[i].SubItems.Count>2 then begin
          sl.Add('file://'+ListView1.Items[i].SubItems[2]);
          sl.Add(ListView1.Items[i].SubItems[0]+':'+ListView1.Items[i].SubItems[1]);
        end;
      end;
//      TChildFrame.Create(Mana22Form, '', fcNONE).NotePad1.LoadFromString(sl.Text);
      ManaMain.MMCreateMDIChild('', fcNONE).LoadFromString(sl.Text);
    finally
      sl.Free;
    end;
  end;
end;

procedure TGrepForm.ListView1DblClick(Sender: TObject);
var
  s: widestring;
begin
  if ListView1.ItemIndex > -1 then begin
    s := ListView1.Selected.SubItems[2];
    if FileExists2(s) then begin
      ManaMain.MMAcceptFile('/j' + ListView1.Selected.SubItems[0], fcNone);
      ManaMain.MMAcceptFile(s, fcNone);
    end;
  end;
end;

procedure TGrepForm.ListView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then begin
    Open1.Click;
    Key := 0;
  end;
end;

procedure TGrepForm.ComboBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then begin
    ButtonGrep1.Click;
    Key := 0;
  end;
end;

procedure TGrepForm.TPopupMenuList1Popup(Sender: TObject);
begin
  Open1.Enabled := (ListView1.ItemIndex > -1);
end;

procedure TGrepForm.Close1Click(Sender: TObject);
begin
  Closed;
  if ManaMain.MMGetPageControl.PageCount = 0 then ManaMain.MMCreateMDIChild('', fcNONE);
  if (ManaMain.MMGetPageControl.ActivePage.Owner is  TChildFrame) then
    TChildFrame(ManaMain.MMGetPageControl.ActivePage.Owner).NotePad1.SetFocus;
end;

procedure TGrepForm.AppReadINI;
var
  INI:TMemIniFileW;
  s:widestring;
  i:integer;
begin
  if not IniFilePathNameA(s) then exit;
  INI := TMemIniFileW.Create(s);
  try
    for i := 0 to 9 do begin
      s := ini.ReadStringW('GREP', 'DIR' + IntToStr(i), '');
      if length(s) > 0 then ComboBoxDir1.Items.Add(s);
      s := ini.ReadStringW('GREP', 'REGEX' + IntToStr(i), '');
      if length(s) > 0 then ComboBoxRegex1.Items.Add(s);
    end;
    CheckBoxSubDir1.Checked := INI.ReadBool('GREP', 'SUBDIR', false);
    CheckBoxCase1.Checked := INI.ReadBool('GREP', 'CASE', false);
    CheckBoxShort1.Checked := INI.ReadBool('GREP', 'SHORT', false);
  finally
    ini.Free;
  end;
end;

function TGrepForm.Closed;
begin
  Result := true;
  //GrepForm := nil;
  KillThread;
  ListView1.Clear;
  AppWriteINI;
  Self.Hide;//eq
  Self.Parent := nil;
  ThisTab.PageControl := nil;
  Free;
end;

procedure TGrepForm.AddNewLine(const pathname, LineString: widestring;
  LineNum: integer);
var
  li:TtntListItem;
begin
  li:=ListView1.Items.Add;
  li.Caption:=ExtractFileNameW(pathname);
  li.SubItems.Add(IntToStr(LineNum+1));
  li.SubItems.Add(LineString);
  li.SubItems.Add(pathname);
  ButtonLog1.Enabled:=true;
end;

procedure TGrepForm.initFilterBox;
//var
//  i:integer;
begin
  EditFilter1.Items.Clear;
  EditFilter1.Items.Add('*.*');
  EditFilter1.Items.Add('*.txt');
{  for i:=0 to DataModule1.DelphiFountain1.FileExtList.Count-1 do begin
    EditFilter1.Items.Add('*'+DataModule1.DelphiFountain1.FileExtList[i]);
  end;
  for i:=0 to DataModule1.HTMLFountain1.FileExtList.Count-1 do begin
    EditFilter1.Items.Add('*'+DataModule1.HTMLFountain1.FileExtList[i]);
  end;
  for i:=0 to DataModule1.PerlFountain1.FileExtList.Count-1 do begin
    EditFilter1.Items.Add('*'+DataModule1.PerlFountain1.FileExtList[i]);
  end;
  for i:=0 to DataModule1.CppFountain1.FileExtList.Count-1 do begin
    EditFilter1.Items.Add('*'+DataModule1.CppFountain1.FileExtList[i]);
  end;
  for i:=0 to DataModule1.JavaFountain1.FileExtList.Count-1 do begin
    EditFilter1.Items.Add('*'+DataModule1.JavaFountain1.FileExtList[i]);
  end;
  for i:=0 to DataModule1.DMSFountain1.FileExtList.Count-1 do begin
    EditFilter1.Items.Add('*'+DataModule1.DMSFountain1.FileExtList[i]);
  end;
  for i:=0 to DataModule1.VBSFountain1.FileExtList.Count-1 do begin
    EditFilter1.Items.Add('*'+DataModule1.VBSFountain1.FileExtList[i]);
  end;
  for i:=0 to DataModule1.CsFountain1.FileExtList.Count-1 do begin
    EditFilter1.Items.Add('*'+DataModule1.CsFountain1.FileExtList[i]);
  end;
  for i:=0 to DataModule1.RubyFountain1.FileExtList.Count-1 do begin
    EditFilter1.Items.Add('*'+DataModule1.RubyFountain1.FileExtList[i]);
  end;
  for i:=0 to DataModule1.PythonFountain1.FileExtList.Count-1 do begin
    EditFilter1.Items.Add('*'+DataModule1.PythonFountain1.FileExtList[i]);
  end;
  for i:=0 to DataModule1.UserFountain1.FileExtList.Count-1 do begin
    EditFilter1.Items.Add('*'+DataModule1.UserFountain1.FileExtList[i]);
  end;
  for i:=0 to DataModule1.UserFountain2.FileExtList.Count-1 do begin
    EditFilter1.Items.Add('*'+DataModule1.UserFountain2.FileExtList[i]);
  end;
}
end;

procedure TGrepForm.AppWriteINI;
var
  INI:TMemIniFileW;
  i:integer;
  fn:widestring;
begin
  if FIniFailed or (not IniFilePathNameA(fn)) then exit;
  INI:= TMemIniFileW.Create(fn);
  try
    for i:=0 to 9 do begin
      if ComboBoxDir1.Items.Count>i then INI.WriteStringW('GREP','DIR'+IntToStr(i),ComboBoxDir1.Items[i]);
      if ComboBoxRegex1.Items.Count>i then INI.WriteStringW('GREP','REGEX'+IntToStr(i),ComboBoxRegex1.Items[i]);
    end;
    INI.WriteBool('GREP','SUBDIR',CheckBoxSubDir1.Checked);
    INI.WriteBool('GREP','CASE',CheckBoxCase1.Checked);
    INI.WriteBool('GREP','SHORT',CheckBoxShort1.Checked);
    INI.UpdateFile;
  except
    FIniFailed := true;
  end;
  if assigned(INI) then INI.Free;
end;

procedure TGrepForm.KillThread;
begin
//  ButtonGrep1.OnClick:=nil;
  Enabled:=false;
  if ExeThread<>nil then begin
    Natural:=false;
    ExeThread.FreeOnTerminate:=false;
    ExeThread.Terminate;
    ExeThread.Suspended:=false;
    ExeThread.WaitFor;
    //ŎE
      ExeThread.Free;
      ExeThread:=nil;
      ButtonGrep1.Caption:='';
  end;
  Enabled:=true;
end;

procedure TGrepForm.OnTerminate(Sender: TObject);
begin
  if (ExeThread<>nil) and Natural then begin
    ExeThread:=nil;
    ButtonGrep1.Caption:='';
  end;
end;

procedure TGrepForm.StartGrep;
var
  s1,s2:widestring;
begin
  if not DirectoryExists2(ComboBoxDir1.Text) then exit;
  if Length(ComboBoxRegex1.Text)<1 then exit;
  if Length(EditFilter1.Text)<1 then exit;
    s1:=ComboBoxDir1.Text;
    if ComboBoxDir1.Items.IndexOf(s1)>-1 then ComboBoxDir1.Items.Delete(ComboBoxDir1.Items.IndexOf(s1));
    ComboBoxDir1.Items.Insert(0,s1);
    ComboBoxDir1.ItemIndex:=0;
    s2:=ComboBoxRegex1.Text;
    if ComboBoxRegex1.Items.IndexOf(s2)>-1 then ComboBoxRegex1.Items.Delete(ComboBoxRegex1.Items.IndexOf(s2));
    ComboBoxRegex1.Items.Insert(0,s2);
    ComboBoxRegex1.ItemIndex:=0;
    ExeThread:=TGrepThread.Create(self, s2,s1,EditFilter1.Text, not CheckBoxCase1.Checked,
                                  CheckBoxShort1.Checked,CheckBoxSubDir1.Checked, true);
    ExeThread.OnTerminate:=self.OnTerminate;
    Natural:=true;
    ListView1.Clear;
    ButtonLog1.Enabled:=false;
    LastPathString:=LabelDir1.Caption+':'+s1+#13#10+
                    LabelRegex1.Caption+':'+s2+#13#10+
                    LabelFilter1.Caption+''+EditFilter1.Text+#13#10+
                    CheckBoxSubDir1.Caption+':'+IntToStr(ord(CheckBoxSubDir1.Checked))+#13#10+
                    CheckBoxCase1.Caption+':'+IntToStr(ord(CheckBoxCase1.Checked))+#13#10+
                    CheckBoxShort1.Caption+':'+IntToStr(ord(CheckBoxShort1.Checked))+#13#10;
    ButtonGrep1.Caption:='~';
    ThisTab.Caption := s2;
    ExeThread.Priority:=tpLower;
    ExeThread.FreeOnTerminate:=true;
    ExeThread.Resume;
    AppWriteINI;
    //{IFreeOnTerminateȊOɎRɎE@͂Ȃ
    //IɎEꍇFreeOnTerminatefalseɂĂ~߂Free
    //
end;

procedure TGrepForm.CreateHandle;
var
  i:integer;
begin
  inherited;
  //Â񂾉B
  if not (csDesigning in ComponentState) then begin
    if ThisTab = nil then begin
      ThisTab := TTabSheetFix.Create(self);
      ThisTab.ParentFont := true;
      ThisTab.ShowHint := false;
      ThisTab.TabStop := false;
      for i := 0 to Mana22Form.ComponentCount - 1 do begin
        if Mana22Form.Components[i] is TTntPageFix then begin
          ThisTab.PageControl := TTntPageFix(Mana22Form.Components[i]);
          break;
        end;
      end;
    end;
  end;
end;

destructor TGrepForm.Destroy;
begin
  if not (csDesigning in ComponentState) then begin
    Self.Hide;//eq
    Self.Parent := nil;
    ThisTab.PageControl := nil;
    ThisTab.Free;
  end;
  inherited;
end;

constructor TGrepForm.Create(AOwner: TComponent);
begin
  inherited;
    TabStop := false;
    OldCreateOrder := false;
    Align := alClient;
    BorderStyle := bsNone;

end;

procedure TGrepForm.WMSetFocus(var Msg: TWMSetFocus);
begin
  inherited;
  if Focused then
    LastNotePad := nil;
  //if Assigned(ViewChanged) then ViewChanged(self);
  ManaMain.MMNotePadViewChanged(self);
end;

procedure TGrepForm.ItemEnter(Sender: TObject);
begin
  LastNotePad := nil;
  ManaMain.MMNotePadViewChanged(self);
end;

end.
