unit ModeDefault;

interface

uses NotePadMode, NotePadString;

type
  TModeDefault = class(TNotePadMode)
  protected
    procedure InitReserveList;override;
  public
    function NewParser(target: TNotePadString): TNotePadParser;override;
  end;

  TParserDefault = class(TNotePadParser)
  private
  protected
    procedure ParseToken(const C: WideChar);overload;override;
  public
    constructor Create(target: TNotePadString; mode: TModeDefault);
  end;

implementation

uses NotePadClasses, ParserConsts;

{ TModeDefault }

procedure TModeDefault.InitReserveList;
var
  a: array of WideString;
begin
  FReserveList := TReserveList.Create(a, true);
  FReserve2List := TReserveList.Create(a, true);
  FReserve3List := TReserveList.Create(a, true);
end;

function TModeDefault.NewParser(target: TNotePadString): TNotePadParser;
begin
  Result := TParserDefault.Create(target, self);
end;

{ TParserDefault }

constructor TParserDefault.Create(target: TNotePadString;
  mode: TModeDefault);
begin
  inherited Create(target, mode);
end;

procedure TParserDefault.ParseToken(const C: WideChar);
begin
  case C of
    toAnk: begin
      FToken := C;
      Ank2Proc;
    end;
    else inherited;
  end;
end;

end.
