unit ShortCutUnit;

interface

uses Windows, Classes, SysUtils;

var
  AvailKeyList: TStringList;

const
  MenuArray: array[0..61] of string =(
  {_~[}'---t@C---',
  'VK쐬',
  't@CJ',
  'J',
  'etH_J',
  '㏑ۑ',
  'Otĕۑ',
  '',
  'S',
  '',
  {_~[}'---ҏW---',
  'ɖ߂',
  '蒼',
  '؂',
  'Rs[',
  '\t',
  '폜',
  'ׂđI',
  'sֈړ',
  'tƎ',
  '͕⊮',
  {_~[}'------',
  '',
  '',
  '',
  'u',
  'nCCg',
  'ݒu',
  'sֈړ',
  '폜',
  'Google {',
  'Google EFuS',
  'Yahoo! ',
  'eLXgt@C',
  {_~[}'---\---',
  '܂ԂȂ',
  'w萔Ő܂Ԃ',
  'E[Ő܂Ԃ',
  'tHgg',
  'tHgk',
  {_~[}'------',
  'tH_Q',
  '֘AÂŊJ',
  'ʂ̃\tgŊJ',
  '܂Ԃsɕϊ',
  'sR[hCRLFɕύX',
  'sR[hLFɕύX',
  'sR[hCRɕύX',
  'pSp',
  'Spp',
  'ŁSJi',
  'SJi',
  'SȁSJi',
  'SJiS',
  '啶',
  '啶',
  'IMEPo^',
  '͌؂ւ',
  'XNvgt@Cs',
  'L[{[h̋L^/~',
  'L[{[h̍Đ',
  {_~[}'---wv---'  );

type
  TShortCutList = Packed record
    {_~[}menuFile,
    actionNew,
    actionFileOpen,
    actionReload,
    actionParent,
    actionSave,
    actionSaveAs,
    actionClose,
    actionCloseAll,
    actionPrint,
    {_~[}menuEdit,
    actionUndo,
    actionRedo,
    actionCut,
    actionCopy,
    actionPaste,
    actionDelete,
    actionSelAll,
    actionGoLine,
    actionDateTime,
    actionComplete,
    {_~[}menuSearch,
    actionFind,
    actionFindPrev,
    actionFindNext,
    actionReplace,
    actionClearHL,
    actionMarkAdd,
    actionMarkJump,
    actionMarkDelete,
    actionGoogle,
    actionWebAll,
    actionYahoo,
    actionGrep,
    {_~[}menuView,
    actionWrapNone,
    actionWrapCount,
    actionWrapRight,
    actionFontUp,
    actionFontDown,
    {_~[}menuCommand,
    actionFolder,
    actionRun,
    actionRunAs,
    actionReturned,
    actionCRLF,
    actionLF,
    actionCR,
    actionHanZen,
    actionZenhan,
    actionHanToZen,
    actionZenToHan,
    actionHiraToKata,
    actionKataToHira,
    actionToUpper,
    actionToLower,
    actionRegWord,
    actionImeChange,
    actionOpenScript,
    actionKeyRec,
    actionKeyPlay,
    {_~[}menuHelp    : TShortCut;
  end;

function CheckShortCutText(const Value: String): String;
function isTopMenu(Value: integer): boolean;
function CheckSameShortCut(const Value: TStringList): boolean; overload;
function CheckSameShortCut(const Value: TShortCutList): boolean; overload;
function CheckSameShortCut(const Value: string; const List: TStringList): boolean; overload;

procedure UnitInitialize;

implementation

uses consts;

const
  SmkcNumP = 'Num +';
  SmkcNumM = 'Num -';

procedure InitAvailKeyList(const List: TStringList);
var
  i: integer;
begin
  List.Add(srNone);
  for i := 1 to 12 do begin
    List.Add('F' + inttostr(i));
  end;
  for i := 1 to 12 do begin
    List.Add(SmkcShift + 'F' + inttostr(i));
  end;
  for i := Integer('A') to Integer('Z') do begin
    List.Add(SmkcCtrl + AnsiChar(i));
  end;
  for i := Integer('0') to Integer('9') do begin
    List.Add(SmkcCtrl + AnsiChar(i));
  end;
  for i := 1 to 12 do begin
    List.Add(SmkcCtrl + 'F' + inttostr(i));
  end;
  List.Add(SmkcCtrl + SmkcIns);
  List.Add(SmkcCtrl + SmkcDel);
  List.Add(SmkcCtrl + SmkcBkSp);
  List.Add(SmkcCtrl + SmkcEnter);
  List.Add(SmkcCtrl + SmkcSpace);
  List.Add(SmkcCtrl + SmkcNumP);
  List.Add(SmkcCtrl + SmkcNumM);
  for i := Integer('A') to Integer('Z') do begin
    List.Add(SmkcShift + SmkcCtrl + AnsiChar(i));
  end;
  for i := Integer('0') to Integer('9') do begin
    List.Add(SmkcShift + SmkcCtrl + AnsiChar(i));
  end;
  for i := 1 to 12 do begin
    List.Add(SmkcShift + SmkcCtrl + 'F' + inttostr(i));
  end;
  List.Add(SmkcShift + SmkcCtrl + SmkcIns);
  List.Add(SmkcShift + SmkcCtrl + SmkcDel);
  List.Add(SmkcShift + SmkcCtrl + SmkcBkSp);
  List.Add(SmkcShift + SmkcCtrl + SmkcEnter);
  List.Add(SmkcShift + SmkcCtrl + SmkcSpace);
  List.Add(SmkcShift + SmkcCtrl + SmkcNumP);
  List.Add(SmkcShift + SmkcCtrl + SmkcNumM);
end;

function CheckShortCutText(const Value: String): String;
begin
  if AvailKeyList.IndexOf(Value) >= 0 then Result := Value else Result := srNone;
end;

function isTopMenu(Value: integer): boolean;
var
  P: integer;
  r: TShortCutList;
begin
  P := integer(@r.menuFile) + Value * sizeof(TShortCut);
  Result := (P = integer(@r.menuFile)) or
            (P = integer(@r.menuEdit)) or
            (P = integer(@r.menuSearch)) or
            (P = integer(@r.menuView)) or
            (P = integer(@r.menuCommand)) or
            (P = integer(@r.menuHelp));
end;

function CheckSameShortCut(const Value: TShortCutList): boolean;
var
  i, j: integer;
  P1, P2: integer;
begin
  Result := true;
  for i := 0 to Length(MenuArray) - 1 do begin
    P1 := integer(@Value.menuFile) + i * sizeof(TShortCut);
    for j := i + 1 to Length(MenuArray) - 1 do begin
      P2 := integer(@Value.menuFile) + j * sizeof(TShortCut);
      if (PWord(P1)^ <> 0) and (PWord(P1)^ = PWord(P2)^) then begin
        Result := false;
        exit;
      end;
    end;
  end;
end;

function CheckSameShortCut(const Value: TStringList): boolean;
var
  i, j: integer;
  S1, S2: String;
begin
  Result := true;
  for i := 0 to Value.Count - 1 do begin
    S1 := Value[i];
    for j := i + 1 to Value.Count - 1 do begin
      S2 := Value[j];
      if (Length(S1) > 0) and (S1 <> srNone) and (S1 = S2) then begin
        Result := false;
        exit;
      end;
    end;
  end;
end;

function CheckSameShortCut(const Value: string; const List: TStringList): boolean; overload;
var
  i: integer;

begin
  Result := true;
  for i := 0 to List.Count - 1 do begin
    if (Length(Value) > 0) and (Value <> srNone) and (Value = List[i]) then begin
      //񌩂Ƃfalseexit
      if Result then Result := false else exit;
    end;
  end;
  result := true;
end;

procedure UnitInitialize;
begin
  AvailKeyList := TStringList.Create;
  InitAvailKeyList(AvailKeyList);
end;

initialization
finalization
  if Assigned(AvailKeyList) then AvailKeyList.Free;
end.
