unit TKCollapsePanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Graphics, Forms;

const
  BarHeight = 18;

type
  TTKCollapsePanel = class(TCustomControl)
  private
    { Private 錾 }
    FTrackMouse: Boolean;
    FExpandHeight: Integer;
    FExpandImageIndex: Integer;
    FCollapseImageIndex: Integer;
    FImageList: TImageList;
    FHotTrack: Boolean;
    FCollapse: Boolean;
    FEnabledCollapse: Boolean;
    FGradientColorB: TColor;
    FGradientColorE: TColor;
    FGradientHotColorB: TColor;
    FGradientHotColorE: TColor;
    FGradientFocusColorB: TColor;
    FGradientFocusColorE: TColor;
    FGradientBodyColorB: TColor;
    FGradientBodyColorE: TColor;
    FGradientDrawBarLeftRight: Boolean;
    FGradientDrawBodyLeftRight: Boolean;
    FHotTrackFontColor: TColor;
    FFrameColor: TColor;
    FOnCollapseBefore: TNotifyEvent;
    FOnCollapseAfter: TNotifyEvent;
    procedure SetCollapse(AValue: Boolean);
    procedure SetImageList(AValue: TImageList);
    procedure SetExpandImageIndex(AValue: Integer);
    procedure SetCollapseImageIndex(AValue: Integer);
    procedure SetExpandHeight(AValue: Integer);

    procedure SetGradientColorB(AValue: TColor);
    procedure SetGradientColorE(AValue: TColor);
    procedure SetGradientHotColorB(AValue: TColor);
    procedure SetGradientHotColorE(AValue: TColor);
    procedure SetGradientFocusColorB(AValue: TColor);
    procedure SetGradientFocusColorE(AValue: TColor);
    procedure SetGradientBodyColorB(AValue: TColor);
    procedure SetGradientBodyColorE(AValue: TColor);
    procedure SetGradientDrawBarLeftRight(AValue: Boolean);
    procedure SetGradientDrawBodyLeftRight(AValue: Boolean);
    procedure SetFrameColor(AValue: TColor);
    //bZ[Wn
    procedure CMTextChanged(var Messages: TMessage); message CM_TEXTCHANGED;
    procedure WMMOUSELEAVE(var Messages: TMessage); message WM_MOUSELEAVE;
    procedure WMSetFocus(var Messages: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Messages: TWMKillFocus); message WM_KILLFOCUS;
    procedure CMDialogChar(var Messages: TCMDialogChar); message CM_DIALOGCHAR;
  protected
    { Protected 錾 }
    procedure Paint; override;
    procedure DrawCanvasGradient(Canvas: TCanvas; ColorB,ColorE: TColor;
      LeftToRight: Boolean; Rect: TRect); //Ofh
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X: Integer; Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X: Integer; Y: Integer); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure ConstrainedResize(var MinWidth, MinHeight,
      MaxWidth, MaxHeight: Integer); override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property Align;
    property Anchors;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop default True;
    property Visible;
    //property Caption;
    property Font;
    property ParentColor;
    property ParentFont;

    property OnClick;
    property OnContextPopup;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;

      property ExpandHeight: Integer read FExpandHeight write SetExpandHeight
        default 100;
      property ImageList: TImageList read FImageList write SetImageList;
      property ExpandImageIndex: Integer read FExpandImageIndex
        write SetExpandImageIndex default -1;
      property CollapseImageIndex: Integer read FCollapseImageIndex
        write SetCollapseImageIndex default -1;
      property Collapse: Boolean read FCollapse write SetCollapse default false;
      property GradientColorB: TColor read FGradientColorB
        write SetGradientColorB default $add3d6;
      property GradientColorE: TColor read FGradientColorE
        write SetGradientColorE default $d6e7ef;
      property GradientHotColorB: TColor read FGradientHotColorB
        write SetGradientHotColorB default $d9c3b1;
      property GradientHotColorE: TColor read FGradientHotColorE
        write SetGradientHotColorE default $e6d7ce;
      property GradientFocusColorB: TColor read FGradientFocusColorB
        write SetGradientFocusColorB default $add3d6;
      property GradientFocusColorE: TColor read FGradientFocusColorE
        write SetGradientFocusColorE default $d6e7ef;
      property GradientBodyColorB: TColor read FGradientBodyColorB
        write SetGradientBodyColorB default $d6ebef;
      property GradientBodyColorE: TColor read FGradientBodyColorE
        write SetGradientBodyColorE default $f2f7f8;
      property EnabledCollapse: Boolean read FEnabledCollapse
        write FEnabledCollapse default true;
      property HotTrackFontColor: TColor read FHotTrackFontColor
        write FHotTrackFontColor default clWhite;
      property FrameColor: TColor read FFrameColor write SetFrameColor
        default $f6efec;

      property GradientDrawBarLeftRight: Boolean read FGradientDrawBarLeftRight
        write SetGradientDrawBarLeftRight default false;
      property GradientDrawBodyLeftRight: Boolean read FGradientDrawBodyLeftRight
        write SetGradientDrawBodyLeftRight default true;

      property OnCollapseBefore: TNotifyEvent read FOnCollapseBefore
        write FOnCollapseBefore;
      property OnCollapseAfter: TNotifyEvent read FOnCollapseAfter
        write FOnCollapseAfter;
  private
    FWideCaption: WideString;
  published
    property Caption: WideString read FWideCaption write FWideCaption;
  end;

procedure Register;

implementation

  procedure TTKCollapsePanel.SetGradientDrawBarLeftRight(AValue: Boolean);
  begin
    FGradientDrawBarLeftRight := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetGradientDrawBodyLeftRight(AValue: Boolean);
  begin
    FGradientDrawBodyLeftRight := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetFrameColor(AValue: TColor);
  begin
    FFrameColor := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetGradientBodyColorB(AValue: TColor);
  begin
    FGradientBodyColorB := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetGradientBodyColorE(AValue: TColor);
  begin
    FGradientBodyColorE := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetGradientColorB(AValue: TColor);
  begin
    FGradientColorB := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetGradientColorE(AValue: TColor);
  begin
    FGradientColorE := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetGradientHotColorB(AValue: TColor);
  begin
    FGradientHotColorB := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetGradientHotColorE(AValue: TColor);
  begin
    FGradientHotColorE := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetGradientFocusColorB(AValue: TColor);
  begin
    FGradientFocusColorB := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetGradientFocusColorE(AValue: TColor);
  begin
    FGradientFocusColorE := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetExpandHeight(AValue: Integer);
  begin
    FExpandHeight := AValue;
    if Collapse = False then
      Height := FExpandHeight;
  end;

  procedure TTKCollapsePanel.ConstrainedResize(var MinWidth, MinHeight,
    MaxWidth, MaxHeight: Integer);
  begin
    inherited;
    if Collapse then
    begin
      //Ă鎞
      MinHeight := BarHeight;
      MaxHeight := BarHeight;
    end;
  end;

  procedure TTKCollapsePanel.CMDialogChar(var Messages: TCMDialogChar);
  begin
    if IsAccel(Messages.CharCode, Caption) and CanFocus then
    begin
      SetFocus;
      Messages.CharCode := 1;
      Collapse := True;
    end else
    begin
      inherited;
    end;
  end;

  procedure TTKCollapsePanel.KeyDown(var Key: Word; Shift: TShiftState);
  begin
    inherited;
    if Key = VK_RETURN then
      Collapse := not Collapse;
  end;

  procedure TTKCollapsePanel.WMSetFocus(var Messages: TWMSetFocus);
  begin
    inherited;
    Invalidate;
  end;

  procedure TTKCollapsePanel.WMKillFocus(var Messages: TWMKillFocus);
  begin
    inherited;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetImageList(AValue: TImageList);
  begin
    FImageList := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetCollapseImageIndex(AValue: Integer);
  begin
    FCollapseImageIndex := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.SetExpandImageIndex(AValue: Integer);
  begin
    FExpandImageIndex := AValue;
    Invalidate;
  end;

  procedure TTKCollapsePanel.CMTextChanged(var Messages: TMessage);
  begin
    inherited;
    Invalidate;
  end;

  procedure TTKCollapsePanel.WMMOUSELEAVE(var Messages: TMessage);
  begin
    inherited;
    FHotTrack := False;
    FTrackMouse := False;
    Invalidate;
  end;

  procedure TTKCollapsePanel.MouseMove(Shift: TShiftState;
    X: Integer; Y: Integer);
  var
    track: tagTRACKMOUSEEVENT;
  begin
    inherited;

    if ((y <= BarHeight) and (y >= 0)) then
    begin
      if FHotTrack = False then
      begin
        FHotTrack := True;
        Invalidate;
        if FTrackMouse = False then
        begin
          FTrackMouse := True;
          track.cbSize := sizeof(track);
          track.dwFlags := TME_LEAVE;
          track.hwndTrack := Handle;
          track.dwHoverTime := HOVER_DEFAULT;
          TrackMouseEvent(track);
        end;
      end;
    end else
    begin
      if FHotTrack then
      begin
        FHotTrack := false;
        Invalidate;
      end;
    end;

  end;


  procedure TTKCollapsePanel.MouseUp(Button: TMouseButton; Shift: TShiftState;
    X: Integer; Y: Integer);
  begin
    inherited;

    if Focused = False then
      SetFocus;

    if (Button = mbLeft) or (Button = mbMiddle) then
    begin
      //`(x͂ǂSʂɂȂ̂œɔʂȂ)
      if (y <= BarHeight) and (y >= 0) then
      begin
        Collapse := not Collapse;
      end;
    end;

    Invalidate;
  end;

  procedure TTKCollapsePanel.SetCollapse(AValue: Boolean);
  begin
    if FCollapse = AValue then exit;
    if FEnabledCollapse = False then
      Exit;

    if Assigned(FOnCollapseBefore) then
    begin
      FOnCollapseBefore(self);
    end;
      
    FCollapse := AValue;
    if FCollapse then
    begin
      //
      Height := BarHeight;
    end else
    begin
      //J
      Height := FExpandHeight;
    end;

    if Assigned(FOnCollapseAfter) then
    begin
      FOnCollapseAfter(self);
    end;
    Update;
  end;

  procedure TTKCollapsePanel.DrawCanvasGradient(Canvas: TCanvas; ColorB,ColorE: TColor;
    LeftToRight: Boolean; Rect: TRect);
  var
    stR,stG,stB,enR,enG,enB,r,g,b: TColor;
    i: integer;
  begin
    stR := GetRValue(ColorToRGB(ColorB));
    stG := GetGValue(ColorToRGB(ColorB));
    stB := GetBValue(ColorToRGB(ColorB));
    enR := GetRValue(ColorToRGB(ColorE));
    enG := GetGValue(ColorToRGB(ColorE));
    enB := GetBValue(ColorToRGB(ColorE));
    if LeftToRight then
    begin
      //E
      for i := Rect.Left to Rect.Right do
      begin
        r := (i * enR + (Rect.Right - i) * stR) div (Rect.Right);
        g := (i * enG + (Rect.Right - i) * stG) div (Rect.Right);
        b := (i * enB + (Rect.Right - i) * stB) div (Rect.Right);
        Canvas.PenPos := Point(i,Rect.Top);
        Canvas.Pen.Color := RGB(r,g,b);
        Canvas.LineTo(i,Rect.Bottom);
      end;
    end else
    begin
      //ォ牺
      for i := Rect.Top to Rect.Bottom do
      begin
        r := (i * enR + (Rect.Bottom - i) * stR) div (Rect.Bottom);
        g := (i * enG + (Rect.Bottom - i) * stG) div (Rect.Bottom);
        b := (i * enB + (Rect.Bottom - i) * stB) div (Rect.Bottom);
        Canvas.PenPos := Point(Rect.Left,i);
        Canvas.Pen.Color := RGB(r,g,b);
        Canvas.LineTo(Rect.Right,i);
      end;
    end;
  end;

  procedure TTKCollapsePanel.Paint;
  var
    BarRect,BodyRect,CapRect: TRect;
    FDrawIcon: Boolean;
    BeginColor,EndColor: TColor;
  begin
    inherited;

    Canvas.Font.Assign(Font);
    Canvas.Font.Style := [fsbold];

    BarRect := Rect(0,0,Width,BarHeight); //TCY߂
    BodyRect := Rect(0,BarHeight+1,Width,Height);
    CapRect := Rect(23,0,Width,BarHeight);

    BeginColor := FGradientColorB;
    EndColor := FGradientColorE;
    if Focused then
    begin
      BeginColor := FGradientFocusColorB;
      EndColor := FGradientFocusColorE;
    end;
    if FHotTrack or (EnabledCollapse = false) then
    begin
      BeginColor := FGradientHotColorB;
      EndColor := FGradientHotColorE;
    end;

    //o[h
      DrawCanvasGradient(Canvas,BeginColor,EndColor,
        FGradientDrawBarLeftRight,BarRect); //Ofh
      Canvas.Pen.Color := FFrameColor;
      Canvas.PenPos := Point(0,0);
      Canvas.LineTo(Width,0);
      Canvas.PenPos := Point(0,BarHeight);
      Canvas.LineTo(Width,BarHeight);

      //tH[JXȂ炳ɘg
      if Focused then
      begin
        Canvas.Pen.Color := clBlack;
        Canvas.Pen.Style := psDot;
        Canvas.Brush.Style := bsClear;
        Canvas.Polygon([Point(0,0),Point(0,BarHeight-1),
          Point(Width-1,BarHeight-1),Point(Width-1,0)]);
        Canvas.Pen.Style := psSolid;
        Canvas.Brush.Style := bsSolid;
      end;

    //{̂h
      DrawCanvasGradient(Canvas,FGradientBodyColorB,
        FGradientBodyColorE,FGradientDrawBodyLeftRight
        ,BodyRect); //Ofh

    //ACRZbgĂΕ`
      FDrawIcon := False;

      if Assigned(FImageList) then
      begin
        if Collapse = False then
        begin
          //JĂ
          if FExpandImageIndex <> -1 then
          begin
            if (FExpandImageIndex > -1) and (FImageList.Count >= FExpandImageIndex) then
            begin
              FImageList.Draw(Canvas,3,0,FExpandImageIndex);
              FDrawIcon := True;
            end;
          end;
        end else
        begin
          //Ă
          if FCollapseImageIndex <> -1 then
          begin
            if (FCollapseImageIndex > -1) and
              (FImageList.Count >= FCollapseImageIndex) then
            begin
              FImageList.Draw(Canvas,3,0,FCollapseImageIndex);
              FDrawIcon := True;
            end;
          end;
        end;
      end;

    //ACRȂ
      if FDrawIcon = False then
      begin
        CapRect.Left := 15; //LvV̏oʒuƉ
        if FHotTrack then
          Canvas.Pen.Color := FHotTrackFontColor
        else
          Canvas.Pen.Color := Font.Color;
        Canvas.Brush.Color := Canvas.Pen.Color;
        Canvas.FrameRect(Rect(2,3,13,14));
        Canvas.MoveTo(4,8);
        Canvas.LineTo(11,8);
        //Op`
        if Collapse then
        begin
          //Canvas.Pen.Color := Font.Color;
          //Canvas.Brush.Color := Font.Color;
//          Canvas.Polygon([Point(5,3),Point(5,15),Point(11,9)]);
          Canvas.MoveTo(7,5);
          Canvas.LineTo(7,12);
        end else
        begin
          //Canvas.Pen.Color := Font.Color;
          //Canvas.Brush.Color := Font.Color;
          //Canvas.Polygon([Point(2,4),Point(7,13),Point(12,4)]);
        end;
      end;

    //Caption`
      if (FHotTrack) then
      begin
        Canvas.Font.Color := FHotTrackFontColor;
      end else
      begin
        Canvas.Font.Color := Font.Color;
      end;
      SetBkMode(Canvas.Handle,TRANSPARENT);
      DrawTextW(Canvas.Handle,PWChar(Caption),-1,CapRect,DT_SINGLELINE or DT_VCENTER);
  end;

  constructor TTKCollapsePanel.Create(AOwner: TComponent);
  begin
    inherited Create(AOwner);
    ControlStyle := ControlStyle + [csAcceptsControls];
    FExpandHeight := 100;
    FExpandImageIndex := -1;
    FCollapseImageIndex := -1;
    FCollapse := False;
    FHotTrack := False;
    FTrackMouse := False;
    TabStop := True;
    DoubleBuffered := True;
    FGradientColorB := $add3d6;
    FGradientColorE := $d6e7ef;
    FGradientHotColorB := $d9c3b1;
    FGradientHotColorE := $e6d7ce;
    FGradientFocusColorB := $add3d6;
    FGradientFocusColorE := $d6e7ef;
    FEnabledCollapse := True;
    FGradientBodyColorB := $d6ebef;
    FGradientBodyColorE := $f2f7f8;
    FHotTrackFontColor := clWhite;
    FGradientDrawBarLeftRight := False;
    FGradientDrawBodyLeftRight := True;
    Height := 200;
    Width := 150;
    FFrameColor := $f6efec;
  end;

procedure Register;
begin
  RegisterComponents('Samples', [TTKCollapsePanel]);
end;

end.
