unit WSHObjects;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Forms, TntForms,
  wNotePad;

type
  TEObj=class(TInterfacedObject, IDispatch)
  private
    FEditor:TwNotePad;
  protected
    function GetTypeInfoCount(out Count: Integer): HResult; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; stdcall;
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; stdcall;
  public
    constructor Create;
  end;

  TAObj=class(TEObj)
  public
    constructor Create;
    procedure SetEditor;
  end;

  TMObj=class(TInterfacedObject, IDispatch)
  private
  protected
    function GetTypeInfoCount(out Count: Integer): HResult; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; stdcall;
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; stdcall;
  public
  end;


implementation

uses ActiveX, InputDialog, HttpApp, childtab, wsFileOp,
 TextFileEncoding, NotePadView, DM;

{ TEObj }

const
  DISPID_GETTEXT = 1;
  DISPID_SETTEXT = 2;
  DISPID_TEXT =3;

  DISPID_GETSELTEXT = 4;
  DISPID_SETSELTEXT = 5;
  DISPID_SELTEXT = 6;

  DISPID_GETSELSTART = 7;
  DISPID_SETSELSTART = 8;
  DISPID_SELSTART =9;

  DISPID_GETSELLENGTH = 10;
  DISPID_SETSELLENGTH = 11;
  DISPID_SELLENGTH =12;

  DISPID_UNDO = 13;
  DISPID_REDO = 14;
  DISPID_CUT = 15;
  DISPID_COPY = 16;
  DISPID_PASTE = 17;
  DISPID_BOXPASTE = 18;
  DISPID_SELECTALL = 19;


  DISPID_GETWORDFROMCARET = 20;
  DISPID_WORDFROMCARET = 21;
  DISPID_GETTOKENFROMCARET = 22;
  DISPID_TOKENFROMCARET = 23;
  DISPID_GETTOKENBRACKETFROMCARET = 24;
  DISPID_TOKENBRACKETFROMCARET = 25;
  DISPID_GETTOKENSTRINGFROMCARET = 26;
  DISPID_TOKENSTRINGFROMCARET = 27;
  DISPID_GETTOKENSTRINGBRACKETFROMCARET = 28;
  DISPID_TOKENSTRINGBRACKETFROMCARET = 29;


  DISPID_SELECTWORDFROMCARET = 30;
  DISPID_SELECTTOKENFROMCARET = 31;
  DISPID_SELECTTOKENBRACKETFROMCARET = 32;

  DISPID_GETSELMODE = 33;
  DISPID_SETSELMODE = 34;

  DISPID_GETFILENAME = 35;
  DISPID_FILENAME = 36;
  DISPID_FORERR_NOTFOUND =1000;

//  DISPID_GETROW = 18;
//  DISPID_SETROW = 19;
//  DISPID_GETCOL = 20;
//  DISPID_SETCOL = 21;

const
  DISPATCH_PROPERTYGET_OR_METHOD = DISPATCH_METHOD or DISPATCH_PROPERTYGET;

constructor TEObj.Create;
begin
  inherited Create;
  FEditor := ManaMain.MMGetSubEditor;
end;

function TEObj.GetIDsOfNames(const IID: TGUID; Names: Pointer; NameCount,
  LocaleID: Integer; DispIDs: Pointer): HResult;
type
  TDispIDsArray = array[0..0] of TDISPID;
  PDispIDsArray = ^TDispIDsArray;
var
  IDs: PDispIDsArray absolute DispIDs;
  i: integer;
  Name: WideString;
begin
  if NameCount > 1 then Result := DISP_E_UNKNOWNNAME
  else
    if NameCount < 1 then Result := E_INVALIDARG
    else Result := S_OK;
  for i := 0 to NameCount - 1 do
    IDs[i] := DISPID_UNKNOWN;
  if NameCount = 1 then
    begin
      Name := PWideChar(Names^);
      Name:=UpperCase(Name);
      if Name = 'GETTEXT' then IDs[0] := DISPID_GETTEXT else
      if Name = 'SETTEXT' then IDs[0] := DISPID_SETTEXT else
      if Name = 'TEXT' then IDs[0] := DISPID_TEXT else
      if Name = 'GETFILENAME' then IDs[0] := DISPID_GETFILENAME else
      if Name = 'FILENAME' then IDs[0] := DISPID_FILENAME else
      if Name = 'GETSELTEXT' then IDs[0] := DISPID_GETSELTEXT else
      if Name = 'SETSELTEXT' then IDs[0] := DISPID_SETSELTEXT else
      if Name = 'SELTEXT' then IDs[0] := DISPID_SELTEXT else
      if Name = 'SELECTALL' then IDs[0] := DISPID_SELECTALL else
      if Name = 'GETSELSTART' then IDs[0] := DISPID_GETSELSTART else
      if Name = 'SETSELSTART' then IDs[0] := DISPID_SETSELSTART else
      if Name = 'SELSTART' then IDs[0] := DISPID_SELSTART else
      if Name = 'GETSELLENGTH' then IDs[0] := DISPID_GETSELLENGTH else
      if Name = 'SETSELLENGTH' then IDs[0] := DISPID_SETSELLENGTH else
      if Name = 'SELLENGTH' then IDs[0] := DISPID_SELLENGTH else
      if Name = 'UNDO' then IDs[0] := DISPID_UNDO else
      if Name = 'REDO' then IDs[0] := DISPID_REDO else
      if Name = 'CUT' then IDs[0] := DISPID_CUT else
      if Name = 'COPY' then IDs[0] := DISPID_COPY else
      if Name = 'PASTE' then IDs[0] := DISPID_PASTE else
      if Name = 'BOXPASTE' then IDs[0] := DISPID_BOXPASTE else
      if Name = 'GETSELMODE' then IDs[0] := DISPID_GETSELMODE else
      if Name = 'SETSELMODE' then IDs[0] := DISPID_SETSELMODE else
{      if Name = 'GETWORDFROMCARET' then IDs[0] := DISPID_GETWORDFROMCARET else
      if Name = 'WORDFROMCARET' then IDs[0] := DISPID_WORDFROMCARET else
      if Name = 'GETTOKENFROMCARET' then IDs[0] := DISPID_GETTOKENFROMCARET else
      if Name = 'TOKENFROMCARET' then IDs[0] := DISPID_TOKENFROMCARET else
      if Name = 'GETTOKENBRACKETFROMCARET' then IDs[0] := DISPID_GETTOKENBRACKETFROMCARET else
      if Name = 'TOKENBRACKETFROMCARET' then IDs[0] := DISPID_TOKENBRACKETFROMCARET else
      if Name = 'GETTOKENSTRINGFROMCARET' then IDs[0] := DISPID_GETTOKENSTRINGFROMCARET else
      if Name = 'TOKENSTRINGFROMCARET' then IDs[0] := DISPID_TOKENSTRINGFROMCARET else
      if Name = 'GETTOKENSTRINGBRACKETFROMCARET' then IDs[0] := DISPID_GETTOKENSTRINGBRACKETFROMCARET else
      if Name = 'TOKENSTRINGBRACKETFROMCARET' then IDs[0] := DISPID_TOKENSTRINGBRACKETFROMCARET else
      if Name = 'SELECTWORDFROMCARET' then IDs[0] := DISPID_SELECTWORDFROMCARET else
      if Name = 'SELECTTOKENFROMCARET' then IDs[0] := DISPID_SELECTTOKENFROMCARET else
      if Name = 'SELECTTOKENBRACKETFROMCARET' then IDs[0] := DISPID_SELECTTOKENBRACKETFROMCARET else
}        Result := DISPID_FORERR_NOTFOUND;//DISP_E_UNKNOWNNAME;
    end;
end;

function TEObj.GetTypeInfo(Index, LocaleID: Integer;
  out TypeInfo): HResult;
begin
  Pointer(TypeInfo) := nil;
  Result := E_NOTIMPL;
end;

function TEObj.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Count := 0;
  Result := S_OK;
end;

function TEObj.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;
type
  PVariantArray = ^TVariantArray;
  TVariantArray = array[0..65535] of Variant;
  PIntegerArray = ^TIntegerArray;
  TIntegerArray = array[0..65535] of Integer;
var
  Parms: PDispParams;
  IsSubEditor:boolean;
  //DISPATCH_METHOD
  ws: WideString;
begin
  IsSubEditor := FEditor = ManaMain.MMGetSubEditor;
  if not IsSubEditor then begin
    FEditor:=ManaMain.MMGetActiveEditor;
  end;
  Parms:=@Params;
  Result:=S_OK;
  case DispID of
    DISPID_GETTEXT:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.Text;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_SETTEXT:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=1 then begin
          if FEditor <> nil then begin
            ws := PVariantArray(Parms.rgvarg)^[0];
            FEditor.ReplaseWithoutSelect(ws, 0, FEditor.TextLength);
            //FEditor.Text:=PVariantArray(Parms.rgvarg)^[0];
          end;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_TEXT:
    begin
      case Flags of
        DISPATCH_PROPERTYGET,DISPATCH_PROPERTYGET_OR_METHOD:
        begin
          if Parms.cArgs=0 then begin
            if (VarResult<>nil)and(FEditor<>nil) then
              POleVariant(VarResult)^ :=FEditor.Text;
          end else Result:=DISP_E_BADPARAMCOUNT;
        end;
        DISPATCH_PROPERTYPUT:
        begin
          if Parms.cArgs=1 then begin
            if FEditor<>nil then begin
              ws := PVariantArray(Parms.rgvarg)^[0];
              FEditor.ReplaseWithoutSelect(ws, 0, FEditor.TextLength);
              //FEditor.Text:=PVariantArray(Parms.rgvarg)^[0];
            end;
          end else Result:=DISP_E_BADPARAMCOUNT;
        end;
        else begin
          Result := DISP_E_MEMBERNOTFOUND;
        end;
      end;
    end;
    DISPID_GETFILENAME:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ := TChildFrame(FEditor.Parent).DocPath;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_FILENAME:
    begin
      if (Flags and DISPATCH_PROPERTYGET)=DISPATCH_PROPERTYGET then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=TChildFrame(FEditor.Parent).DocPath;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_GETSELTEXT:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.SelectedText;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_SETSELTEXT:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=1 then begin
          if FEditor<>nil then FEditor.SelectedText:=PVariantArray(Parms.rgvarg)^[0];
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_SELTEXT:
    begin
      case Flags of
        DISPATCH_PROPERTYGET,DISPATCH_PROPERTYGET_OR_METHOD:
        begin
          if Parms.cArgs=0 then begin
            if (VarResult<>nil)and(FEditor<>nil) then
              POleVariant(VarResult)^ :=FEditor.SelectedText;
          end else Result:=DISP_E_BADPARAMCOUNT;
        end;
        DISPATCH_PROPERTYPUT:
        begin
          if Parms.cArgs=1 then begin
            if FEditor<>nil then FEditor.SelectedText:=PVariantArray(Parms.rgvarg)^[0];
          end else Result:=DISP_E_BADPARAMCOUNT;
        end;
        else begin
          Result := DISP_E_MEMBERNOTFOUND;
        end;
      end;
    end;
    DISPID_GETSELSTART:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.SelectionStart;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_SETSELSTART:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=1 then begin
          if FEditor<>nil then FEditor.SelectionStart:=PVariantArray(Parms.rgvarg)^[0];
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_SELSTART:
    begin
      case Flags of
        DISPATCH_PROPERTYGET,DISPATCH_PROPERTYGET_OR_METHOD:
        begin
          if Parms.cArgs=0 then begin
            if (VarResult<>nil)and(FEditor<>nil) then
              POleVariant(VarResult)^ :=FEditor.SelectionStart;
          end else Result:=DISP_E_BADPARAMCOUNT;
        end;
        DISPATCH_PROPERTYPUT:
        begin
          if Parms.cArgs=1 then begin
            if FEditor<>nil then FEditor.SelectionStart:=PVariantArray(Parms.rgvarg)^[0];
          end else Result:=DISP_E_BADPARAMCOUNT;
        end;
        else begin
          Result := DISP_E_MEMBERNOTFOUND;
        end;
      end;
    end;
    DISPID_GETSELLENGTH:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.SelectionLength;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_SETSELLENGTH:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=1 then begin
          if FEditor<>nil then FEditor.SelectionLength:=PVariantArray(Parms.rgvarg)^[0];
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_SELLENGTH:
    begin
      case Flags of
        DISPATCH_PROPERTYGET,DISPATCH_PROPERTYGET_OR_METHOD:
        begin
          if Parms.cArgs=0 then begin
            if (VarResult<>nil)and(FEditor<>nil) then
              POleVariant(VarResult)^ :=FEditor.SelectionLength;
          end else Result:=DISP_E_BADPARAMCOUNT;
        end;
        DISPATCH_PROPERTYPUT:
        begin
          if Parms.cArgs=1 then begin
            if FEditor<>nil then FEditor.SelectionLength:=PVariantArray(Parms.rgvarg)^[0];
          end else Result:=DISP_E_BADPARAMCOUNT;
        end;
        else begin
          Result := DISP_E_MEMBERNOTFOUND;
        end;
      end;
    end;
    DISPID_UNDO:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if FEditor<>nil then FEditor.Undo;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_REDO:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if FEditor<>nil then FEditor.Redo;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_CUT:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if FEditor<>nil then FEditor.Cut;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_COPY:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if FEditor<>nil then FEditor.Copy;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_PASTE:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if FEditor<>nil then FEditor.Paste;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_SELECTALL:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if FEditor<>nil then FEditor.SelectAll;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_GETSELMODE:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ := FEditor.BoxSelectMode;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_SETSELMODE:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=1 then begin
          if FEditor<>nil then FEditor.BoxSelectMode := PVariantArray(Parms.rgvarg)^[0];
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
{    DISPID_GETWORDFROMCARET:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.WordFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_WORDFROMCARET:
    begin
      if (Flags and DISPATCH_PROPERTYGET)=DISPATCH_PROPERTYGET then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.WordFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_GETTOKENFROMCARET:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.TokenFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_TOKENFROMCARET:
    begin
      if (Flags and DISPATCH_PROPERTYGET)=DISPATCH_PROPERTYGET then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.TokenFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_GETTOKENBRACKETFROMCARET:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.TokenBracketFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_TOKENBRACKETFROMCARET:
    begin
      if (Flags and DISPATCH_PROPERTYGET)=DISPATCH_PROPERTYGET then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.TokenBracketFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_GETTOKENSTRINGFROMCARET:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.TokenStringFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_TOKENSTRINGFROMCARET:
    begin
      if (Flags and DISPATCH_PROPERTYGET)=DISPATCH_PROPERTYGET then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.TokenStringFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_GETTOKENSTRINGBRACKETFROMCARET:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.TokenStringBracketFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_TOKENSTRINGBRACKETFROMCARET:
    begin
      if (Flags and DISPATCH_PROPERTYGET)=DISPATCH_PROPERTYGET then begin
        if Parms.cArgs=0 then begin
          if (VarResult<>nil)and(FEditor<>nil) then
            POleVariant(VarResult)^ :=FEditor.TokenStringBracketFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_SELECTWORDFROMCARET:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if FEditor<>nil then FEditor.SelectWordFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_SELECTTOKENFROMCARET:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if FEditor<>nil then FEditor.SelectTokenFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_SELECTTOKENBRACKETFROMCARET:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if FEditor<>nil then FEditor.SelectTokenBracketFromCaret;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;   }
    else Result := DISP_E_MEMBERNOTFOUND;
  end;//case
end;

{ TMObj }
const
  DISPID_GETEXENAME  = 1;
  DISPID_EXENAME  = 2;
  DISPID_ALERTDIALOG = 3;
  DISPID_NEWEDITOR = 4;
  DISPID_CONFIRMDIALOG = 5;
  DISPID_INPUTDIALOG = 6;
  DISPID_HTTPENCODE =7;


function TMObj.GetIDsOfNames(const IID: TGUID; Names: Pointer; NameCount,
  LocaleID: Integer; DispIDs: Pointer): HResult;
type
  TDispIDsArray = array[0..0] of TDISPID;
  PDispIDsArray = ^TDispIDsArray;
var
  IDs: PDispIDsArray absolute DispIDs;
  i: integer;
  Name: WideString;
begin
  if NameCount > 1 then Result := DISP_E_UNKNOWNNAME
  else
    if NameCount < 1 then Result := E_INVALIDARG
    else Result := S_OK;
  for i := 0 to NameCount - 1 do
    IDs[i] := DISPID_UNKNOWN;
  if NameCount = 1 then
    begin
      Name := PWideChar(Names^);
      Name:=UpperCase(Name);
      if Name = 'GETEXENAME' then IDs[0] := DISPID_GETEXENAME else
      if Name = 'EXENAME' then IDs[0] := DISPID_EXENAME else
      if Name = 'ALERTDIALOG' then IDs[0] := DISPID_ALERTDIALOG else
      if Name = 'NEWEDITOR' then IDs[0] := DISPID_NEWEDITOR else
      if Name = 'CONFIRMDIALOG' then IDs[0] := DISPID_CONFIRMDIALOG else
      if Name = 'INPUTDIALOG' then IDs[0] := DISPID_INPUTDIALOG else
      IF Name = 'HTTPENCODE' then IDs[0]:= DISPID_HTTPENCODE else
       Result := DISPID_FORERR_NOTFOUND;//DISP_E_UNKNOWNNAME;
    end;
end;

function TMObj.GetTypeInfo(Index, LocaleID: Integer;
  out TypeInfo): HResult;
begin
  Pointer(TypeInfo) := nil;
  Result := E_NOTIMPL;
end;

function TMObj.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Count := 0;
  Result := S_OK;
end;

function TMObj.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;
type
  PVariantArray = ^TVariantArray;
  TVariantArray = array[0..65535] of Variant;
  PIntegerArray = ^TIntegerArray;
  TIntegerArray = array[0..65535] of Integer;
var
  Parms: PDispParams;
  ws:widestring;
  i:integer;
begin
  Result := S_OK;
  Parms := @Params;
  case DispID of
    DISPID_GETEXENAME:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          if VarResult<>nil then
            POleVariant(VarResult)^ := paramstrw(0);
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_EXENAME:
    begin
      if (Flags and DISPATCH_PROPERTYGET)=DISPATCH_PROPERTYGET then begin
        if Parms.cArgs=0 then begin
          if VarResult<>nil then
            POleVariant(VarResult)^ := paramstrw(0);
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_ALERTDIALOG:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=1 then begin
          MessageBoxW(Application.Handle,pwchar(widestring(PVariantArray(Parms.rgvarg)^[0])),pwchar(TntApplication.Title),MB_OK or MB_TASKMODAL);
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_NEWEDITOR:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=0 then begin
          ManaMain.MMCreateMDIChild('', fcNone);
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_CONFIRMDIALOG:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=1 then begin
          i:=MessageBoxW(Application.Handle,pwchar(widestring(PVariantArray(Parms.rgvarg)^[0])),pwchar(TntApplication.Title),MB_OKCANCEL or MB_ICONQUESTION or MB_TASKMODAL);
          if VarResult<>nil then POleVariant(VarResult)^:=i;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_INPUTDIALOG:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=1 then begin
          ws:='';
          NumberInputBox(ManaMain.MMGetHandle, TntApplication.Title,PVariantArray(Parms.rgvarg)^[0],ws,false);
          if VarResult<>nil then POleVariant(VarResult)^:=ws;
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;
    DISPID_HTTPENCODE:
    begin
      if (Flags and DISPATCH_METHOD)=DISPATCH_METHOD then begin
        if Parms.cArgs=1 then begin
          if VarResult<>nil then POleVariant(VarResult)^:=HTTPEncode(PVariantArray(Parms.rgvarg)^[0]);
        end else Result:=DISP_E_BADPARAMCOUNT;
      end else Result:=DISP_E_MEMBERNOTFOUND;
    end;

    else Result := DISP_E_MEMBERNOTFOUND;

  end;//case
end;

{ TAObj }

constructor TAObj.Create;
begin
  Inherited Create;
  SetEditor;
end;

procedure TAObj.SetEditor;
begin
  FEditor:=ManaMain.MMGetActiveEditor;
end;

end.
